<img src="https://github.com/QuantumKitHub/Strided.jl/blob/main/docs/src/assets/logo.svg"
width="150">

# Strided.jl

Strided array views with efficient (cache-friendly and multithreaded) manipulations

| **Build Status** | **Coverage** | **Quality assurance** | **Downloads** |
|:----------------:|:------------:|:---------------------:|:--------------|
| [![CI][ci-img]][ci-url] [![CI (Julia nightly)][ci-julia-nightly-img]][ci-julia-nightly-url] | [![Codecov][codecov-img]][codecov-url] | [![Aqua QA][aqua-img]][aqua-url] | [![Strided Downloads][downloads-img]][downloads-url] |

[github-img]: https://github.com/QuantumKitHub/Strided.jl/workflows/CI/badge.svg
[github-url]: https://github.com/QuantumKitHub/Strided.jl/actions?query=workflow%3ACI

[ci-img]: https://github.com/QuantumKitHub/Strided.jl/workflows/CI/badge.svg
[ci-url]: https://github.com/QuantumKitHub/Strided.jl/actions?query=workflow%3ACI

[ci-julia-nightly-img]:
    https://github.com/QuantumKitHub/Strided.jl/workflows/CI%20(Julia%20nightly)/badge.svg
[ci-julia-nightly-url]:
    https://github.com/QuantumKitHub/Strided.jl/actions?query=workflow%3A%22CI+%28Julia+nightly%29%22

[codecov-img]: https://codecov.io/gh/QuantumKitHub/Strided.jl/branch/main/graph/badge.svg
[codecov-url]: https://codecov.io/gh/QuantumKitHub/Strided.jl

[aqua-img]: https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg
[aqua-url]: https://github.com/JuliaTesting/Aqua.jl

[downloads-img]: https://img.shields.io/badge/dynamic/json?url=http%3A%2F%2Fjuliapkgstats.com%2Fapi%2Fv1%2Ftotal_downloads%2FStrided&query=total_requests&label=Downloads
[downloads-url]: http://juliapkgstats.com/pkg/Strided

A Julia package for working more efficiently with strided arrays, i.e. dense arrays whose
memory layout has a fixed stride along every dimension. Strided.jl does not make any
assumptions about the strides (such as stride 1 along first dimension, or monotonically
increasing strides) and provides multithreaded and cache friendly implementations for
mapping, reducing, broadcasting such arrays, as well as taking views, reshaping and
permuting dimensions. Most of these are simply accessible by annotating a block of standard
Julia code involving broadcasting and other array operations with the macro `@strided`.
Currently, Strided.jl only supports arrays in the main memory and does not provide
implementations for arrays on GPUs or other hardware accelerators.

# What's new

Strided.jl v2 reduces the complexity of the implementation. It discards of the
`UnsafeStridedView` type, which was pointer based and required to avoid allocations prior to
Julia v1.5 (because of [#14955](https://github.com/JuliaLang/julia/issues/14955)). The
associated `@unsafe_strided` macro has been deprecated.

The main structured type `StridedView` for representing a strided view over a contiguous
array (`DenseArray`) is now defined in a separate package
[StridedViews.jl](https://github.com/Jutho/StridedViews.jl). This definition is device
agnostic and can thus also be used in combination with dense GPU arrays. However, at the
moment, the methods implemented in Strided.jl are restricted to strided views over `Array`
data.

# Examples

Running Julia with a single thread

```julia
julia> using Strided

julia> using BenchmarkTools

julia> A = randn(4000,4000);

julia> B = similar(A);

julia> @btime $B .= ($A .+ $A') ./ 2;
  145.214 ms (0 allocations: 0 bytes)

julia> @btime @strided $B .= ($A .+ $A') ./ 2;
  56.189 ms (6 allocations: 352 bytes)

julia> A = randn(1000,1000);

julia> B = similar(A);

julia> @btime $B .= 3 .* $A';
  2.449 ms (0 allocations: 0 bytes)

julia> @btime @strided $B .= 3 .* $A';
  1.459 ms (5 allocations: 288 bytes)

julia> @btime $B .= $A .* exp.( -2 .* $A) .+ sin.( $A .* $A);
  22.493 ms (0 allocations: 0 bytes)

julia> @btime @strided $B .= $A .* exp.( -2 .* $A) .+ sin.( $A .* $A);
  22.240 ms (10 allocations: 480 bytes)

julia> A = randn(32,32,32,32);

julia> B = similar(A);

julia> @btime permutedims!($B, $A, (4,3,2,1));
  5.203 ms (2 allocations: 128 bytes)

julia> @btime @strided permutedims!($B, $A, (4,3,2,1));
  2.201 ms (4 allocations: 320 bytes)

julia> @btime $B .= permutedims($A, (1,2,3,4)) .+ permutedims($A, (2,3,4,1)) .+ permutedims($A, (3,4,1,2)) .+ permutedims($A, (4,1,2,3));
  21.863 ms (32 allocations: 32.00 MiB)

julia> @btime @strided $B .= permutedims($A, (1,2,3,4)) .+ permutedims($A, (2,3,4,1)) .+ permutedims($A, (3,4,1,2)) .+ permutedims($A, (4,1,2,3));
  8.495 ms (9 allocations: 640 bytes)
```
And now with `export JULIA_NUM_THREADS = 4`
```julia
julia> using Strided

julia> using BenchmarkTools

julia> A = randn(4000,4000);

julia> B = similar(A);

julia> @btime $B .= ($A .+ $A') ./ 2;
  146.618 ms (0 allocations: 0 bytes)

julia> @btime @strided $B .= ($A .+ $A') ./ 2;
  30.355 ms (12 allocations: 912 bytes)

julia> A = randn(1000,1000);

julia> B = similar(A);

julia> @btime $B .= 3 .* $A';
  2.030 ms (0 allocations: 0 bytes)

julia> @btime @strided $B .= 3 .* $A';
  808.874 μs (11 allocations: 784 bytes)

julia> @btime $B .= $A .* exp.( -2 .* $A) .+ sin.( $A .* $A);
  21.971 ms (0 allocations: 0 bytes)

julia> @btime @strided $B .= $A .* exp.( -2 .* $A) .+ sin.( $A .* $A);
  5.811 ms (16 allocations: 1.05 KiB)

julia> A = randn(32,32,32,32);

julia> B = similar(A);

julia> @btime permutedims!($B, $A, (4,3,2,1));
  5.334 ms (2 allocations: 128 bytes)

julia> @btime @strided permutedims!($B, $A, (4,3,2,1));
  1.192 ms (10 allocations: 928 bytes)

julia> @btime $B .= permutedims($A, (1,2,3,4)) .+ permutedims($A, (2,3,4,1)) .+ permutedims($A, (3,4,1,2)) .+ permutedims($A, (4,1,2,3));
  22.465 ms (32 allocations: 32.00 MiB)

julia> @btime @strided $B .= permutedims($A, (1,2,3,4)) .+ permutedims($A, (2,3,4,1)) .+ permutedims($A, (3,4,1,2)) .+ permutedims($A, (4,1,2,3));
  2.796 ms (15 allocations: 1.44 KiB)
```

# Design principles

## `StridedView`

Strided.jl is centered around the type `StridedView`, which provides a view into a parent
array of type `DenseArray` such that the resulting view is strided. The definition of this
type, together with the set of methods that create `StridedView` instances, and transform
them into eachother, are now implemented in
[StridedViews.jl](https://github.com/Jutho/StridedViews.jl). This package is device agnostic
and never actually operators on the data in a nontrivial manner.

## Broadcasting and `map(reduce)`

Whenever an expression only contains `StridedView`s and non-array objects (scalars),
overloaded methods for broadcasting and functions as `map(!)` and `mapreduce` are used that
exploit the known strided structure in order to evaluate the result in a more efficient way,
at least for sufficiently large arrays where the overhead of the extra preparatory work is
negligible. In particular, this involves choosing a blocking strategy and loop order that
aims to avoid cache misses. This matters in particular if some of the `StridedView`s
involved have strides which are not monotonously increasing, e.g. if `transpose`, `adjoint`
or `permutedims` has been applied. The fact that the latter also acts lazily (whereas it
creates a copy of the data in Julia base) can potentially provide a further speedup.

## The `@strided` macro annotation
Rather than manually wrapping every array in a `StridedView`, there is the macro annotation
`@strided some_expression`, which will wrap all `DenseArray`s appearing in `some_expression`
in a `StridedView`. Note that, because `StridedView`s behave lazily under indexing with
ranges, this acts similar to the `@views` macro in Julia Base, i.e. there is no need to use
a view.

The macro `@strided` acts as a contract, i.e. the user ensures that all array manipulations
in the following expressions will preserve the strided structure. Therefore, `reshape` and
`view` are are replaced by `sreshape` and `sview` respectively. As mentioned above,
`sreshape` will throw an error if the requested new shape is incompatible with preserving
the strided structure. The function `sview` is only defined for index arguments which are
ranges, `Int`s or `Colon` (`:`), and will thus also throw an error if indexed by anything
else.

## Multithreading support

The optimized methods in Strided.jl are implemented with support for multithreading. Thus,
if `Threads.nthreads() > 1` and the arrays involved are sufficiently large, performance can
be boosted even for plain arrays with a strictly sequential memory layout, provided that the
broadcast operation is compute bound and not memory bound (i.e. the broadcast function is
sufficienlty complex).

Strided.jl uses the @spawn threading infrastructure, and the number of tasks that will be
spawned is customizable via the function `Strided.set_num_threads(n)`, where `n` can be any
integer between 1 (no threading) and `Base.Threads.nthreads()`. This allows to spend only a
part of the Julia threads on multithreading, i.e. Strided will never spawn more than `n-1`
additional tasks. By default, `n = Base.Threads.nthreads()`, i.e. threading is enabled by
default. There are also convenience functions `Strided.enable_threads() =
Strided.set_num_threads(Threads.nthreads())` and `Strided.disable_threads() =
Strided.set_num_threads(1)`.

Furthermore, there is an experimental feature (disabled by default) to apply multithreading
for matrix multiplication using a divide-and-conquer strategy. It can be enabled via
`Strided.enable_threaded_mul()` (and similarly `Strided.disable_threaded_mul()` to revert to
the default setting). For matrices with a `LinearAlgebra.BlasFloat` element type (i.e. any
of `Float32`, `Float64`, `ComplexF32` or `ComplexF64`), this is typically not necessary as
BLAS is multithreaded by default. However, it can be beneficial to implement the
multithreading using Julia Tasks, which then run on Julia's threads as distributed by
Julia's scheduler. Hence, this feature should likely be used in combination with
`LinearAlgebra.BLAS.set_num_threads(1)`. Performance seems to be on par (within a few
percent margin) with the threading strategies of OpenBLAS and MKL. However, note that the
latter call also disables any multithreading used in LAPACK (e.g. `eigen`, `svd`, `qr`, ...)
and Strided.jl does not help with that.

## `StridedView` versus `StridedArray` and BLAS/LAPACK compatibility

`StridedArray` is a union type to denote arrays with a strided structure in Julia Base.
Because of its definition as a type union rather than an abstract type, it is impossible to
have user types be recognized as `StridedArray`. This is rather unfortunate, since
dispatching to BLAS and LAPACK routines is based on `StridedArray`. As a consequence,
`StridedView` will not fall back to BLAS or LAPACK by default. Currently, only matrix
multiplication is overloaded so as to fall back to BLAS (i.e. `gemm!`) if possible. In
general, one should not attempt use e.g. matrix factorizations or other lapack operations
within the `@strided` context. Support for this is on the TODO list. Some BLAS inspired
methods (`axpy!`, `axpby!`, scalar multiplication via `mul!`, `rmul!` or `lmul!`) are
however overloaded by relying on the optimized yet generic `map!` implementation.

`StridedView`s can currently only be created with certainty from `DenseArray` (typically
just `Array` in Julia Base). For `Base.SubArray` or `Base.ReshapedArray` instances, the
`StridedView` constructor will first act on the underlying parent array, and then try to
mimic the corresponding view or reshape operation using `sview` and `sreshape`. These,
however, are more limited then their Base counterparts (because they need to guarantee that
the result still has a strided memory layout with respect to the new dimensions), so an
error can result. However, this approach can also succeed in creating `StridedView` wrappers
around combinations of `view` and `reshape` that are not recognised as `Base.StridedArray`.
For example, `reshape(view(randn(40,40), 1:36, 1:20), (6,6,5,4))` is not a
`Base.StridedArrray`, and indeed, it cannot statically be inferred to be strided, from only
knowing the argument types provided to `view` and `reshape`. For example, the similarly
looking `reshape(view(randn(40,40), 1:36, 1:20), (6,3,10,4))` is not strided. The
`StridedView` constructor will try to act on both, and yield a runtime error in the second
case. Note that `Base.ReinterpretArray` is currently not supported.

Note again that, unlike `StridedArray`s, `StridedView`s behave lazily (i.e. still produce a
view on the same parent array) under `permutedims` and regular indexing with ranges.

# Planned features / wish list

*   Support for `GPUArray`s with dedicated GPU kernels?

function Base.Array(a::StridedView)
    b = Array{eltype(a)}(undef, size(a))
    copyto!(StridedView(b), a)
    return b
end

function (Base.Array{T})(a::StridedView{S,N}) where {T,S,N}
    b = Array{T}(undef, size(a))
    copyto!(StridedView(b), a)
    return b
end

function (Base.Array{T,N})(a::StridedView{S,N}) where {T,S,N}
    b = Array{T}(undef, size(a))
    copyto!(StridedView(b), a)
    return b
end

module StridedcuBLASExt

using Strided, StridedViews, cuBLAS, cuBLAS.CUDACore, LinearAlgebra
import Strided: blas_mul!

const CuStridedView{T, N, A <: CuArray{T}} = StridedViews.StridedView{T, N, A}

function Strided.blas_mul!(C::CuStridedView{T, 2}, A::CuStridedView{T, 2}, B::CuStridedView{T, 2}, α::Number, β::Number) where {T <: LinearAlgebra.BlasFloat}
    A2, CA = Strided.getblasmatrix(A)
    B2, CB = Strided.getblasmatrix(B)
    C2, CC = Strided.getblasmatrix(C)
    A2a = Base.unsafe_wrap(CuMatrix{T}, pointer(A2), size(A2))
    B2a = Base.unsafe_wrap(CuMatrix{T}, pointer(B2), size(B2))
    C2a = Base.unsafe_wrap(CuMatrix{T}, pointer(C2), size(C2))
    cuBLAS.gemm!(CA, CB, convert(T, α), A2a, B2a, convert(T, β), C2a)
    return C
end

end

# Methods based on map!
Base.copy!(dst::StridedView{<:Any, N}, src::StridedView{<:Any, N}) where {N} = map!(identity, dst, src)
Base.conj!(a::StridedView{<:Real}) = a
Base.conj!(a::StridedView) = map!(conj, a, a)
LinearAlgebra.adjoint!(dst::StridedView, src::StridedView) = copy!(dst, adjoint(src))
LinearAlgebra.transpose!(C::StridedView, A::StridedView) = copy!(C, transpose(A))
Base.permutedims!(dst::StridedView, src::StridedView, p) = copy!(dst, permutedims(src, p))
Base.fill!(A::StridedView, val) = map!(Returns(val), A, A)

# This is a wrapper function intended to allow us to
# intercept "conj" and rewrite it in cases where the
# GPU compiler seemingly isn't compiling bare conj
# correctly (https://github.com/QuantumKitHub/Strided.jl/issues/63).
# It should be removed as soon as the underlying
# compilation problem is resolved. It uses the first
# argument to dispatch so that only AMD arrays are affected.
_get_op(A::StridedView) = A.op

function Base.mapreduce(f, op, A::StridedView; dims = :, kw...)
    return Base._mapreduce_dim(f, op, values(kw), A, dims)
end

function Base._mapreduce_dim(f, op, nt::NamedTuple{(:init,)}, A::StridedView, ::Colon)
    return _mapreduce(f, op, A, nt)
end
Base._mapreduce_dim(f, op, ::NamedTuple{()}, A::StridedView, ::Colon) = _mapreduce(f, op, A)

function Base._mapreduce_dim(f, op, nt::NamedTuple{(:init,)}, A::StridedView, dims)
    return Base.mapreducedim!(f, op, Base.reducedim_initarray(A, dims, nt.init), A)
end
function Base._mapreduce_dim(f, op, ::NamedTuple{()}, A::StridedView, dims)
    return Base.mapreducedim!(f, op, Base.reducedim_init(f, op, A, dims), A)
end

function Base.map(
        @nospecialize(f), a1::StridedView{<:Any, N},
        A::Vararg{StridedView{<:Any, N}}
    ) where {N}
    T = Base.promote_eltype(a1, A...)
    return map!(f, similar(a1, T), a1, A...)
end

function Base.map!(
        @nospecialize(f), b::StridedView{<:Any, N}, a1::StridedView{<:Any, N},
        A::Vararg{StridedView{<:Any, N}}
    ) where {N}
    dims = size(b)

    # Check dimesions
    size(a1) == dims || throw(DimensionMismatch())
    for a in A
        size(a) == dims || throw(DimensionMismatch())
    end

    any(isequal(0), dims) && return b # don't do anything

    _mapreduce_order!(f, nothing, nothing, dims, (b, a1, A...))

    return b
end

function _mapreduce(@nospecialize(f), @nospecialize(op), A::StridedView{T}, nt = nothing) where {T}
    if isempty(A)
        b = Base.mapreduce_empty(f, op, T)
        return nt === nothing ? b : op(b, nt.init)
    end

    dims = size(A)
    a = Base.mapreduce_first(f, op, first(A))
    a2 = nt === nothing ? a : op(a, nt.init)
    ndims(A) == 0 && return a2 # 0-dim scalar: single-element reduction is the result
    out = similar(A, typeof(a2), (1,))
    if nt === nothing
        _init_reduction!(out, f, op, a)
    else
        out[ParentIndex(1)] = nt.init
    end
    _mapreducedim!(f, op, nothing, dims, (sreshape(out, one.(dims)), A))
    return out[ParentIndex(1)]
end

function Base.mapreducedim!(
        @nospecialize(f), @nospecialize(op), b::StridedView{<:Any, N},
        a1::StridedView{<:Any, N},
        A::Vararg{StridedView{<:Any, N}}
    ) where {N}
    outdims = size(b)
    dims = map(max, outdims, map(max, map(size, (a1, A...))...))

    # Check dimensions
    Broadcast.check_broadcast_axes(map(Base.OneTo, dims), b, a1, A...)

    return _mapreducedim!(f, op, nothing, dims, (b, a1, A...))
end

function _mapreducedim!(
        @nospecialize(f), @nospecialize(op), @nospecialize(initop),
        dims::Dims, arrays::Tuple{Vararg{StridedView}}
    )
    if any(isequal(0), dims)
        if length(arrays[1]) != 0 && !isnothing(initop)
            map!(initop, arrays[1], arrays[1])
        end
    else
        _mapreduce_order!(f, op, initop, dims, promoteshape(dims, arrays...))
    end
    return arrays[1]
end

# Cache-friendly reordering of the loop dimensions: put the most important
# (smallest-stride, most contiguous) dimension first and size-1 dimensions last.
# The importance of each dimension is modelled from the `indexorder` of every
# array's strides, with the output array (`strides[1]`) weighted by a factor 2.
# `strides` is the per-array tuple-of-tuples; returns the reordered `(dims, strides)`.
function _sortdims(dims, strides)
    M = length(strides)
    N = length(dims)
    # ceil(Int, log2(M+2)) # to account for the fact that there are M arrays, where the first one is counted with a factor 2
    g = 8 * sizeof(Int) - leading_zeros(M + 1)
    importance = 2 .* (1 .<< (g .* (N .- indexorder(strides[1]))))
    for k in 2:M
        importance = importance .+ (1 .<< (g .* (N .- indexorder(strides[k]))))
    end

    importance = importance .* (dims .> 1) # put dims 1 at the back
    p = TupleTools.sortperm(importance; rev = true)
    return TupleTools.getindices(dims, p), broadcast(TupleTools.getindices, strides, (p,))
end

# Fuse dimensions if possible: merge dimension `i` into `i-1` when the two are
# contiguous in *every* array (`s[i] == dims[i-1] * s[i-1]`).
# Merged dimensions fold their extent into `i-1` and become size 1.
function _fusedims(dims, allstrides)
    @inbounds for i in length(dims):-1:2
        merge = true
        for s in allstrides
            if s[i] != dims[i - 1] * s[i - 1]
                merge = false
                break
            end
        end
        if merge
            dims = TupleTools.setindex(dims, dims[i - 1] * dims[i], i - 1)
            dims = TupleTools.setindex(dims, 1, i)
        end
    end
    return dims
end

function order_and_fuse_dims(dims, allstrides)
    dims, allstrides = _sortdims(dims, allstrides)
    dims = _fusedims(dims, allstrides)
    return _sortdims(dims, allstrides)
end

# Per-dimension cost used by the blocking and thread-splitting heuristics,
# derived from the minimum (doubled) stride across arrays.
_computecosts(strides) = map(a -> ifelse(iszero(a), 1, a << 1), map(min, strides...))

# Pipeline entry point: order → fuse → order → block → kernel.
# Fusing needs ordered entries, and final order pass brings remaining dim 1 to end
function _mapreduce_order!(
        @nospecialize(f), @nospecialize(op), @nospecialize(initop),
        dims::Dims, arrays::Tuple{Vararg{StridedView}}
    )
    isempty(dims) && return _mapreduce_scalar!(f, op, initop, arrays)
    dims, allstrides = order_and_fuse_dims(dims, map(strides, arrays))
    offsets = map(offset, arrays)
    costs = _computecosts(allstrides)
    return _mapreduce_block!(f, op, initop, dims, allstrides, offsets, costs, arrays)
end

# 0-dimensional fast path: bypass @generated kernel
function _mapreduce_scalar!(@nospecialize(f), @nospecialize(op), @nospecialize(initop), arrays)
    out = arrays[1]
    iout = ParentIndex(offset(out) + 1)
    v = f(map(a -> a[ParentIndex(offset(a) + 1)], Base.tail(arrays))...)
    if op === nothing
        out[iout] = v
    else
        o = initop === nothing ? out[iout] : initop(out[iout])
        out[iout] = op(o, v)
    end
    return nothing
end

const MINTHREADLENGTH = 1 << 15 # minimal length before any kind of threading is applied
function _mapreduce_block!(
        @nospecialize(f), @nospecialize(op), @nospecialize(initop),
        dims, strides, offsets, costs, arrays
    )
    bytestrides = map((s, stride) -> s .* stride, sizeof.(eltype.(arrays)), strides)
    strideorders = map(indexorder, strides)
    blocks = _computeblocks(dims, costs, bytestrides, strideorders)

    # t = @elapsed _computeblocks(dims, costs, bytestrides, strideorders)
    # println("_computeblocks time: $t")

    if get_num_threads() == 1 || prod(dims) <= MINTHREADLENGTH
        _mapreduce_kernel!(f, op, initop, dims, blocks, arrays, strides, offsets)
    elseif op !== nothing && _length(dims, strides[1]) == 1 # complete reduction
        T = eltype(arrays[1])
        spacing = isbitstype(T) ? max(1, div(64, sizeof(T))) : 1 # to avoid false sharing
        threadedout = similar(arrays[1], spacing * get_num_threads())
        a = arrays[1][ParentIndex(1)]
        if initop !== nothing
            a = initop(a)
        end
        _init_reduction!(threadedout, f, op, a)

        newarrays = (threadedout, Base.tail(arrays)...)
        _mapreduce_threaded!(
            f, op, nothing, dims, blocks, strides, offsets, costs,
            newarrays, get_num_threads(), spacing, 1
        )

        for i in 1:get_num_threads()
            a = op(a, threadedout[(i - 1) * spacing + 1])
        end
        arrays[1][ParentIndex(1)] = a
    else
        costs = costs .* .!(iszero.(strides[1]))
        # make cost of dimensions with zero stride in output array (reduction dimensions),
        # so that they are not divided in threading (which would lead to race conditions)

        _mapreduce_threaded!(
            f, op, initop, dims, blocks, strides, offsets, costs, arrays,
            get_num_threads(), 0, 1
        )
    end
    return nothing
end

_init_reduction!(out, f, op::Union{typeof(+), typeof(Base.add_sum)}, a) = fill!(out, zero(a))
_init_reduction!(out, f, op::Union{typeof(*), typeof(Base.mul_prod)}, a) = fill!(out, one(a))
_init_reduction!(out, f, op::typeof(min), a) = fill!(out, a)
_init_reduction!(out, f, op::typeof(max), a) = fill!(out, a)
_init_reduction!(out, f, op::typeof(&), a) = fill!(out, true)
_init_reduction!(out, f, op::typeof(|), a) = fill!(out, false)
function _init_reduction!(out, f, op, a)
    return op(a, a) == a ? fill!(out, a) :
        error("unknown reduction; incompatible with multithreading")
end

# nthreads: number of threads spacing: extra addition to offset of array 1, to account for
# reduction
function _mapreduce_threaded!(
        @nospecialize(f), @nospecialize(op), @nospecialize(initop),
        dims, blocks, strides, offsets, costs, arrays, nthreads,
        spacing, taskindex
    )
    if nthreads == 1 || prod(dims) <= MINTHREADLENGTH
        offset1 = offsets[1] + spacing * (taskindex - 1)
        spacedoffsets = (offset1, Base.tail(offsets)...)
        _mapreduce_kernel!(f, op, initop, dims, blocks, arrays, strides, spacedoffsets)
    else
        i = _lastargmax((dims .- 1) .* costs)
        if iszero(costs[i]) || dims[i] <= min(blocks[i], 1024)
            offset1 = offsets[1] + spacing * (taskindex - 1)
            spacedoffsets = (offset1, Base.tail(offsets)...)
            _mapreduce_kernel!(f, op, initop, dims, blocks, arrays, strides, spacedoffsets)
        else
            di = dims[i]
            ndi = di >> 1
            nnthreads = nthreads >> 1
            newdims = setindex(dims, ndi, i)
            newoffsets = offsets
            t = Threads.@spawn _mapreduce_threaded!(
                f, op, initop, newdims, blocks, strides,
                newoffsets, costs, arrays, nnthreads,
                spacing, taskindex
            )
            stridesi = getindex.(strides, i)
            newoffsets2 = offsets .+ ndi .* stridesi
            newdims2 = setindex(dims, di - ndi, i)
            nnthreads2 = nthreads - nnthreads
            _mapreduce_threaded!(
                f, op, initop, newdims2, blocks, strides, newoffsets2,
                costs, arrays, nnthreads2, spacing, taskindex + nnthreads
            )
            wait(t)
        end
    end
    return nothing
end

function _mapreduce_kernel_expr(f, op, initop, N::Int, M::Int)
    @assert N > 0 "Cannot generate 0-dim kernel"

    # many variables
    blockloopvars = Array{Symbol}(undef, N)
    blockdimvars = Array{Symbol}(undef, N)
    innerloopvars = Array{Symbol}(undef, N)
    initblockdimvars = Array{Symbol}(undef, N)
    initvars = Array{Symbol}(undef, N + 1)
    for i in 1:N
        blockloopvars[i] = Symbol(:J, i)
        blockdimvars[i] = Symbol(:d, i)
        innerloopvars[i] = Symbol(:j, i)
        initblockdimvars[i] = Symbol(:d′, i)
        initvars[i] = Symbol(:init, i)
    end
    initvars[N + 1] = Symbol(:init, N + 1)

    Ivars = Array{Symbol}(undef, M)
    Avars = Array{Symbol}(undef, M)
    stridevars = Array{Symbol}(undef, (N, M))
    for j in 1:M
        Ivars[j] = Symbol(:I, j)
        Avars[j] = Symbol(:A, j)
        for i in 1:N
            stridevars[i, j] = Symbol(:stride_, i, :_, j)
        end
    end

    # useful expressions
    pre1ex = Expr(:block)
    pre2ex = Expr(:block)
    pre3ex = Expr(:block)
    for j in 1:M
        push!(pre1ex.args, :($(Avars[j]) = arrays[$j]))
        push!(pre3ex.args, :($(Ivars[j]) = offsets[$j] + 1))
        for i in 1:N
            push!(pre2ex.args, :($(stridevars[i, j]) = strides[$j][$i]))
        end
    end

    fcallex = Expr(:call, :f)
    for j in 2:M
        push!(fcallex.args, :($(Avars[j])[ParentIndex($(Ivars[j]))]))
    end
    lhsex = :(A1[ParentIndex($(Ivars[1]))])

    stepstride1ex = Vector{Expr}(undef, N)
    stepstride2ex = Vector{Expr}(undef, N)
    returnstride1ex = Vector{Expr}(undef, N)
    returnstride2ex = Vector{Expr}(undef, N)
    for i in 1:N
        stepstride1ex[i] = :($(Ivars[1]) += $(stridevars[i, 1]))
        returnstride1ex[i] = :($(Ivars[1]) -= $(blockdimvars[i]) * $(stridevars[i, 1]))
        stepex = Expr(:block)
        returnex = Expr(:block)
        for j in 2:M
            push!(stepex.args, :($(Ivars[j]) += $(stridevars[i, j])))
            push!(returnex.args, :($(Ivars[j]) -= $(blockdimvars[i]) * $(stridevars[i, j])))
        end
        stepstride2ex[i] = stepex
        returnstride2ex[i] = returnex
    end

    outerstepstrideex = Vector{Expr}(undef, N)
    outerreturnstrideex = Vector{Expr}(undef, N)
    for i in 1:N
        stepex = Expr(:block)
        returnex = Expr(:block)
        for j in 1:M
            push!(stepex.args, :($(Ivars[j]) += $(blockdimvars[i]) * $(stridevars[i, j])))
            push!(returnex.args, :($(Ivars[j]) -= dims[$i] * $(stridevars[i, j])))
        end
        outerstepstrideex[i] = stepex
        outerreturnstrideex[i] = returnex
    end

    # Unit-stride fast path for the innermost (vectorized) loop dimension.
    # We special-case for contiguous loads/stores to avoid SIMD gather/scatter
    # in favor of SIMD load/store, which streams memory more efficiently.
    unitstep1ex = :($(Ivars[1]) += 1)
    unitstep2ex = Expr(:block)
    for j in 2:M
        push!(unitstep2ex.args, :($(Ivars[j]) += 1))
    end
    firststrides = Expr(:tuple, (stridevars[1, j] for j in 1:M)...)
    unitstridecond = :(all(==(1), $firststrides))

    i = 1
    if op == Nothing
        # Non-reducing (map!/permute/...): each destination element is written once,
        # so skip the reduction-only `iszero` hoist below and emit just the
        # unit-stride and generic `@simd` loops.
        ex = Expr(:(=), lhsex, fcallex)
        if N >= 1
            ex = quote
                if $unitstridecond
                    @simd for $(innerloopvars[i]) in Base.OneTo($(blockdimvars[i]))
                        $ex
                        $unitstep1ex
                        $unitstep2ex
                    end
                    $(returnstride1ex[i])
                    $(returnstride2ex[i])
                else
                    @simd for $(innerloopvars[i]) in Base.OneTo($(blockdimvars[i]))
                        $ex
                        $(stepstride1ex[i])
                        $(stepstride2ex[i])
                    end
                    $(returnstride1ex[i])
                    $(returnstride2ex[i])
                end
            end
        end
    else
        ex = Expr(:(=), lhsex, Expr(:call, :op, lhsex, fcallex))
        exa = Expr(:(=), :a, Expr(:call, :op, :a, fcallex))
        if N >= 1
            ex = quote
                if iszero($(stridevars[1, 1])) # explicitly hoist A1[I1] out of loop
                    a = $lhsex
                    @simd for $(innerloopvars[i]) in Base.OneTo($(blockdimvars[i]))
                        $exa
                        $(stepstride2ex[i])
                    end
                    $lhsex = a
                    $(returnstride2ex[i])
                elseif $unitstridecond
                    @simd for $(innerloopvars[i]) in Base.OneTo($(blockdimvars[i]))
                        $ex
                        $unitstep1ex
                        $unitstep2ex
                    end
                    $(returnstride1ex[i])
                    $(returnstride2ex[i])
                else
                    @simd for $(innerloopvars[i]) in Base.OneTo($(blockdimvars[i]))
                        $ex
                        $(stepstride1ex[i])
                        $(stepstride2ex[i])
                    end
                    $(returnstride1ex[i])
                    $(returnstride2ex[i])
                end
            end
        end
    end
    for outer i in 2:N
        ex = quote
            for $(innerloopvars[i]) in Base.OneTo($(blockdimvars[i]))
                $ex
                $(stepstride1ex[i])
                $(stepstride2ex[i])
            end
            $(returnstride1ex[i])
            $(returnstride2ex[i])
        end
    end

    if initop !== Nothing
        initex = Expr(:(=), lhsex, Expr(:call, :initop, lhsex))
        i = 1
        if N >= 1
            initex = quote
                $(initblockdimvars[i]) = ifelse(
                    iszero($(stridevars[i, 1])), 1,
                    $(blockdimvars[i])
                )
                @simd for $(innerloopvars[i]) in Base.OneTo($(initblockdimvars[i]))
                    $initex
                    $(stepstride1ex[i])
                end
                $(Ivars[1]) -= $(initblockdimvars[i]) * $(stridevars[i, 1])
            end
        end
        for outer i in 2:N
            initex = quote
                $(initblockdimvars[i]) = ifelse(
                    iszero($(stridevars[i, 1])), 1,
                    $(blockdimvars[i])
                )
                for $(innerloopvars[i]) in Base.OneTo($(initblockdimvars[i]))
                    $initex
                    $(stepstride1ex[i])
                end
                $(Ivars[1]) -= $(initblockdimvars[i]) * $(stridevars[i, 1])
            end
        end
        ex = quote
            if $(initvars[1])
                $initex
            end
            $ex
        end
    end

    if initop === Nothing
        for outer i in 1:N
            ex = quote
                for $(blockloopvars[i]) in 1:blocks[$i]:dims[$i]
                    $(blockdimvars[i]) = min(blocks[$i], dims[$i] - $(blockloopvars[i]) + 1)
                    $ex
                    $(outerstepstrideex[i])
                end
                $(outerreturnstrideex[i])
            end
        end
        ex = quote
            $pre1ex
            $pre2ex
            $pre3ex
            @inbounds $ex
            return A1
        end
    else
        for outer i in 1:N
            ex = quote
                $(initvars[i]) = $(initvars[i + 1])
                for $(blockloopvars[i]) in 1:blocks[$i]:dims[$i]
                    $(blockdimvars[i]) = min(blocks[$i], dims[$i] - $(blockloopvars[i]) + 1)
                    $ex
                    $(initvars[i]) &= $(stridevars[i, 1]) > 0
                    $(outerstepstrideex[i])
                end
                $(outerreturnstrideex[i])
            end
        end
        ex = quote
            $pre1ex
            $pre2ex
            $pre3ex
            $(initvars[N + 1]) = true
            @inbounds $ex
            return A1
        end
    end
    return ex
end

@generated function _mapreduce_kernel!(
        (f), (op),
        (initop), dims::NTuple{N, Int},
        blocks::NTuple{N, Int},
        arrays::NTuple{M, StridedView},
        strides::NTuple{M, NTuple{N, Int}},
        offsets::NTuple{M, Int}
    ) where {N, M}
    return _mapreduce_kernel_expr(f, op, initop, N, M)
end

function indexorder(strides::NTuple{N, Int}) where {N}
    # returns order such that strides[i] is the order[i]th smallest element of strides, not
    # counting zero strides zero strides have order 1
    return ntuple(Val(N)) do i
        si = abs(strides[i])
        iszero(si) && return 1
        k = 1
        for s in strides
            if !iszero(s) && abs(s) < si
                k += 1
            end
        end
        return k
    end
end

function _length(dims::Tuple, strides::Tuple)
    return ifelse(iszero(strides[1]), 1, dims[1]) *
        _length(Base.tail(dims), Base.tail(strides))
end
_length(dims::Tuple{}, strides::Tuple{}) = 1
function _maxlength(dims::Tuple, strides::Tuple{Vararg{Tuple}})
    return maximum(broadcast(_length, (dims,), strides))
end

function _lastargmax(t::Tuple)
    i = 1
    for j in 2:length(t)
        @inbounds if t[j] >= t[i]
            i = j
        end
    end
    return i
end

const BLOCKMEMORYSIZE = 1 << 15 # L1 cache size in bytes
function _computeblocks(
        dims::Tuple{}, costs::Tuple{},
        bytestrides::Tuple{Vararg{Tuple{}}},
        strideorders::Tuple{Vararg{Tuple{}}},
        blocksize::Int = BLOCKMEMORYSIZE
    )
    return ()
end

function _computeblocks(
        dims::NTuple{N, Int}, costs::NTuple{N, Int},
        bytestrides::Tuple{Vararg{NTuple{N, Int}}},
        strideorders::Tuple{Vararg{NTuple{N, Int}}},
        blocksize::Int = BLOCKMEMORYSIZE
    ) where {N}
    if totalmemoryregion(dims, bytestrides) <= blocksize
        return dims
    end
    minstrideorder = minimum(minimum.(strideorders))
    if all(isequal(minstrideorder), first.(strideorders))
        d1 = dims[1]
        dr = _computeblocks(
            tail(dims), tail(costs),
            map(tail, bytestrides), map(tail, strideorders), blocksize
        )
        return (d1, dr...)
    end

    if minimum(minimum.(bytestrides)) > blocksize
        return ntuple(n -> 1, Val(N))
    end

    # reduce dims to find appropriate blocks
    blocks = dims
    while totalmemoryregion(blocks, bytestrides) >= 2 * blocksize
        i = _lastargmax((blocks .- 1) .* costs)
        blocks = TupleTools.setindex(blocks, (blocks[i] + 1) >> 1, i)
    end
    while totalmemoryregion(blocks, bytestrides) > blocksize
        i = _lastargmax((blocks .- 1) .* costs)
        blocks = TupleTools.setindex(blocks, blocks[i] - 1, i)
    end
    return blocks
end

const _cachelinelength = 64
function totalmemoryregion(dims, bytestrides)
    memoryregion = 0
    for i in 1:length(bytestrides)
        strides = bytestrides[i]
        numcontigeouscachelines = 0
        numcachelineblocks = 1
        for (d, s) in zip(dims, strides)
            if s < _cachelinelength
                numcontigeouscachelines += (d - 1) * s
            else
                numcachelineblocks *= d
            end
        end
        numcontigeouscachelines = div(numcontigeouscachelines, _cachelinelength) + 1
        memoryregion += _cachelinelength * numcontigeouscachelines * numcachelineblocks
    end
    return memoryregion
end

module StridedGPUArraysExt

using Strided, GPUArrays, LinearAlgebra
using GPUArrays: Adapt, KernelAbstractions
using GPUArrays.KernelAbstractions: @kernel, @index
using StridedViews: ParentIndex

import Strided: isblasmatrix, _get_op

ALL_FS = Union{typeof(adjoint), typeof(conj), typeof(identity), typeof(transpose)}

# StridedView backed by any GPU array type, with element type linked to the parent.
const GPUStridedView{T, N} = StridedView{T, N, <:AnyGPUArray{T}}

KernelAbstractions.get_backend(sv::GPUStridedView) = KernelAbstractions.get_backend(parent(sv))

# Conversion to CPU Array: materialise into a contiguous GPU array first (so the
# GPU-to-GPU copy! path is used), then let the GPU array type handle the transfer.
function Base.Array(a::GPUStridedView)
    b = similar(parent(a), eltype(a), size(a))
    copy!(StridedView(b), a)
    return Array(b)
end

# ---------- GPU mapreduce support ----------

@inline _gpu_init_acc(::Nothing, current_val) = current_val
@inline _gpu_init_acc(initop, current_val) = initop(current_val)

@inline _gpu_accum(::Nothing, acc, val) = val
@inline _gpu_accum(op, acc, val) = op(acc, val)

@inline function cartesian2parent(strides::NTuple{N, Int}, cidx::CartesianIndex{N}) where {N}
    s = 0
    for d in Base.OneTo(N)
        @inbounds s += strides[d] * (cidx[d] - 1)
    end
    return s
end

@kernel function _mapreduce_gpu_kernel!(
        f, op, initop,
        dims_red, strides, offsets, ops, arrays
    )

    I_out = @index(Global, Cartesian)

    # Compute parent index for current index.
    Is_parent = cartesian2parent.(strides, Ref(I_out)) .+ offsets .+ 1

    # Initialize accumulator from current output value (or apply initop)
    out = arrays[1]
    out_I_parent = Is_parent[1]
    @inbounds acc = _gpu_init_acc(initop, ops[1](out[out_I_parent]))

    inputs = Base.tail(arrays)
    inputs_I_parent = Base.tail(Is_parent)
    inputs_strides = Base.tail(strides)
    inputs_ops = Base.tail(ops)

    for I_red in CartesianIndices(dims_red)
        # Compute parent index for current reduction index
        Is_red_parent = cartesian2parent.(inputs_strides, Ref(I_red))
        Is_inputs = inputs_I_parent .+ Is_red_parent
        # Get values from each input array, apply map function, and accumulate
        vals = map(inputs, inputs_ops, Is_inputs) do in, in_op, in_I
            in_op(getindex(in, in_I))
        end
        acc = _gpu_accum(op, acc, f(vals...))
    end
    # Write back result to output array
    @inbounds out[out_I_parent] = ops[1](acc)
end

# GPU-compatible _mapreduce: avoids scalar indexing (first(A), out[ParentIndex(1)])
# that JLArrays/real GPUs prohibit. Mirrors GPUArrays' neutral_element approach:
# infer output type via Broadcast machinery, look up the neutral element (errors on
# unknown ops), fill the output buffer, then read back a single scalar via Array().
function Strided._mapreduce(
        f, op, A::GPUStridedView{T, N}, nt = nothing
    ) where {T, N}
    if isempty(A)
        b = Base.mapreduce_empty(f, op, T)
        return nt === nothing ? b : op(b, nt.init)
    end

    dims = size(A)

    if nt === nothing
        ET = Base.Broadcast.combine_eltypes(f, (A,))
        ET = Base.promote_op(op, ET, ET)
        (ET === Union{} || ET === Any) &&
            error("cannot infer output element type for mapreduce; pass an explicit `init`")
        init = GPUArrays.neutral_element(op, ET)
    else
        ET = typeof(nt.init)
        init = nt.init
    end

    out = similar(parent(A), ET, (1,))
    fill!(out, init)

    Strided._mapreducedim!(f, op, nothing, dims, (sreshape(StridedView(out), one.(dims)), A))

    return Array(out)[1]
end

# 0-dimensional fast path: bypass @generated kernel
# needs GPU specific extension to avoid scalar indexing error
function Strided._mapreduce_scalar!(
        @nospecialize(f), @nospecialize(op), @nospecialize(initop),
        arrays::Tuple{GPUStridedView{TO, 0}, Vararg{GPUStridedView{<:Any, 0}}}
    ) where {TO}
    out = arrays[1]
    iout = ParentIndex(Strided.offset(out) + 1)
    @allowscalar begin
        v = f(map(a -> a[ParentIndex(Strided.offset(a) + 1)], Base.tail(arrays))...)
        if op === nothing
            out[iout] = v
        else
            o = initop === nothing ? out[iout] : initop(out[iout])
            out[iout] = op(o, v)
        end
    end
    return nothing
end

function Strided._mapreduce_block!(
        f, op, initop,
        dims::Dims{N},
        strides, offsets, costs,
        arrays::Tuple{GPUStridedView{TO, N}, Vararg{GPUStridedView{<:Any, N}}}
    ) where {TO, N}

    out = arrays[1]
    out_strides = strides[1]

    # Number of output elements = product of non-reduction dims
    dims_out = ntuple(Val(N)) do d
        @inbounds iszero(out_strides[d]) ? 1 : dims[d]
    end
    dims_red = ntuple(Val(N)) do d
        @inbounds iszero(out_strides[d]) ? dims[d] : 1
    end

    backend = KernelAbstractions.get_backend(parent(out))
    kernel! = _mapreduce_gpu_kernel!(backend)
    ops = _get_op.(arrays)
    kernel!(f, op, initop, dims_red, strides, offsets, ops, parent.(arrays); ndrange = dims_out)
    return nothing
end

function Strided.isblasmatrix(A::GPUStridedView{T, 2}) where {T <: LinearAlgebra.BlasFloat}
    if A.op == identity
        # unsafe wrap approach doesn't work if second condition not met
        return stride(A, 1) == 1 && size(A, 1) == size(parent(A), 1)
    elseif A.op == conj
        # this is converted to adjoint
        # unsafe wrap approach doesn't work if second condition not met
        return stride(A, 2) == 1 && size(A, 2) == size(parent(A), 2)
    else # should never happen
        return false
    end
end

end

module StridedAMDGPUExt

using Strided, StridedViews, AMDGPU, AMDGPU.rocBLAS, LinearAlgebra
import Strided: blas_mul!, _get_op

const ROCStridedView{T, N, A <: ROCArray{T}} = StridedViews.StridedView{T, N, A}

function Strided.blas_mul!(C::ROCStridedView{T, 2}, A::ROCStridedView{T, 2}, B::ROCStridedView{T, 2}, α::Number, β::Number) where {T <: LinearAlgebra.BlasFloat}
    A2, CA = Strided.getblasmatrix(A)
    B2, CB = Strided.getblasmatrix(B)
    C2, CC = Strided.getblasmatrix(C)
    A2a = Base.unsafe_wrap(ROCMatrix{T}, pointer(A2), size(A2))
    B2a = Base.unsafe_wrap(ROCMatrix{T}, pointer(B2), size(B2))
    C2a = Base.unsafe_wrap(ROCMatrix{T}, pointer(C2), size(C2))
    AMDGPU.rocBLAS.gemm!(CA, CB, convert(T, α), A2a, B2a, convert(T, β), C2a)
    return C
end

_conj(x) = real(x) - imag(x) * im
@static if VERSION < v"1.11.0-rc"
    # work around compiler issue on AMD on 1.10
    _get_op(A::ROCStridedView) = A.op == conj ? _conj : A.op
else
    _get_op(A::ROCStridedView) = A.op
end

end

macro strided(ex)
    ex = macroexpand(__module__, ex)
    return esc(_strided(ex))
end

function _strided(ex::Expr)
    if ex.head == :. && ex.args[2] isa QuoteNode # field access: wrap whole expression in maybestrided
        return Expr(:call, :(Strided.maybestrided), ex)
    elseif ex.head == :call && ex.args[1] isa Symbol
        if ex.args[1] == :reshape
            return Expr(:call, :(Strided.sreshape), map(_strided, ex.args[2:end])...)
        elseif ex.args[1] == :view
            return Expr(:call, :(Strided.sview), map(_strided, ex.args[2:end])...)
        else
            return Expr(:call, ex.args[1], map(_strided, ex.args[2:end])...)
        end
    elseif (ex.head == :(=) || ex.head == :(kw)) && ex.args[1] isa Symbol
        return Expr(
            ex.head, ex.args[1],
            Expr(:call, :(Strided.maybeunstrided), _strided(ex.args[2]))
        )
    elseif (ex.head == :(->))
        return Expr(
            ex.head, ex.args[1],
            Expr(:call, :(Strided.maybeunstrided), _strided(ex.args[2]))
        )
    else
        return Expr(ex.head, map(_strided, ex.args)...)
    end
end
const exclusionlist = Symbol[:(:)]
_strided(ex::Symbol) = ex in exclusionlist ? ex : Expr(:call, :(Strided.maybestrided), ex)
_strided(ex) = ex

maybestrided(A::StridedView) = A
maybestrided(A::AbstractArray) = StridedView(A)
maybestrided(A::Tuple) = maybestrided.(A)
maybestrided(A) = A
function maybeunstrided(A::StridedView)
    Ap = A.parent
    if size(A) == size(Ap) && strides(A) == strides(Ap) && offset(A) == 0 &&
            A.op == identity
        return Ap
    else
        return reshape(copy(A).parent, size(A))
    end
end
maybeunstrided(A::Tuple) = maybeunstrided.(A)
maybeunstrided(A) = A

# TODO: deprecate
macro unsafe_strided(args...)
    syms = args[1:(end - 1)]
    ex = macroexpand(__module__, args[end]) #_strided(args[end])
    all(isa(s, Symbol) for s in syms) ||
        error("The first arguments to `@unsafe_strided` must be variable names")

    ex = Expr(:let, Expr(:block, [:($s = Strided.StridedView($s)) for s in syms]...), ex)
    warnex = :(
        Base.depwarn(
            "`@unsafe_strided A B C ... ex` is deprecated, use `@strided ex` instead.",
            Symbol("@unsafe_strided"); force = true
        )
    )
    return esc(Expr(:block, warnex, ex))
end

export @unsafe_strided

for T1 in (Float32, Float64, Complex{Float32}, Complex{Float64})
    for T2 in (Float32, Float64, Complex{Float32}, Complex{Float64})
        @testset "Matrix multiplication with StridedView: $T1 times $T2" begin
            d = 103
            A1 = rand(T1, (d, d))
            A2 = rand(T2, (d, d))
            T3 = promote_type(T1, T2)
            A3 = rand(T3, (d, d))
            A4 = rand(T3, (d, d))
            B1 = StridedView(A1)
            B2 = StridedView(A2)
            B3 = StridedView(A3)
            B4 = StridedView(A4)

            for op1 in (identity, conj, transpose, adjoint)
                @test op1(A1) == op1(B1)
                for op2 in (identity, conj, transpose, adjoint)
                    @test op1(A1) * op2(A2) ≈ op1(B1) * op2(B2)
                    for op3 in (identity, conj, transpose, adjoint)
                        α = randn(T3)
                        β = randn(T3)
                        copy!(A3, A4)
                        mul!(op3(B3), op1(B1), op2(B2), α, β)
                        @test B3 ≈ op3(β) * A4 + op3(α * op1(A1) * op2(A2)) # op3 is its own inverse
                    end
                end
            end
        end

        @testset "Outer product with StridedView: $T1 times $T2" begin
            d = 10
            A1 = rand(T1, (d, 1))
            A2 = rand(T2, (1, d))
            T3 = promote_type(T1, T2)
            A3 = rand(T3, (d, d))
            A4 = rand(T3, (d, d))
            B1 = StridedView(A1)
            B2 = StridedView(A2)
            B3 = StridedView(A3)
            B4 = StridedView(A4)
            α = randn(T3)
            β = randn(T3)
            for op1 in (identity, conj)
                @test op1(A1) == op1(B1)
                for op2 in (identity, conj)
                    @test op1(A1) * op2(A2) ≈ op1(B1) * op2(B2)
                    for op3 in (identity, conj, transpose, adjoint)
                        α = randn(T3)
                        β = randn(T3)
                        copy!(A3, A4)
                        mul!(op3(B3), op1(B1), op2(B2), α, β)
                        @test B3 ≈ op3(β) * A4 + op3(α * op1(A1) * op2(A2)) # op3 is its own inverse
                    end
                end
            end
        end

        @testset "Inner product with StridedView: $T1 times $T2" begin
            d = 10
            A1 = rand(T1, (1, d))
            A2 = rand(T2, (d, 1))
            T3 = promote_type(T1, T2)
            A3 = rand(T3, (1, 1))
            A4 = rand(T3, (1, 1))
            B1 = StridedView(A1)
            B2 = StridedView(A2)
            B3 = StridedView(A3)
            B4 = StridedView(A4)
            α = randn(T3)
            β = randn(T3)
            for op1 in (identity, conj)
                @test op1(A1) == op1(B1)
                for op2 in (identity, conj)
                    @test op1(A1) * op2(A2) ≈ op1(B1) * op2(B2)
                    for op3 in (identity, conj, transpose, adjoint)
                        α = randn(T3)
                        β = randn(T3)
                        copy!(A3, A4)
                        mul!(op3(B3), op1(B1), op2(B2), α, β)
                        @test B3 ≈ op3(β) * A4 + op3(α * op1(A1) * op2(A2)) # op3 is its own inverse
                    end
                end
            end
        end
    end
end

@testset "Matrix multiplication with length 0" begin
    A = rand(2, 0)
    B = rand(0, 2)
    C = rand(2, 2)
    α = rand()
    β = rand()
    A1 = StridedView(copy(A))
    B1 = StridedView(copy(B))
    C1 = StridedView(copy(C))
    @test mul!(C, A, B, α, β) ≈ mul!(C1, A1, B1, α, β)
end

module Strided

import Base: parent, size, strides, tail, setindex
using Base: @propagate_inbounds, RangeIndex, Dims
const SliceIndex = Union{RangeIndex, Colon}

using LinearAlgebra

using TupleTools
# using TupleTools: StaticLength

using StridedViews
using StridedViews: offset, ParentIndex

# re-export?
export StridedView, @strided, sreshape, sview, isstrided

const _NTHREADS = Ref(1)
get_num_threads() = _NTHREADS[]

function set_num_threads(n::Int)
    N = Base.Threads.nthreads()
    if n > N
        n = N
        _set_num_threads_warn(n)
    end
    return _NTHREADS[] = n
end
@noinline function _set_num_threads_warn(n)
    return @warn "Maximal number of threads limited by number of Julia threads,
            setting number of threads equal to Threads.nthreads() = $n"
end

enable_threads() = set_num_threads(Base.Threads.nthreads())
disable_threads() = set_num_threads(1)

const _use_threaded_mul = Ref(false)
use_threaded_mul() = _use_threaded_mul[]

function disable_threaded_mul()
    _use_threaded_mul[] = false
    return
end

function enable_threaded_mul()
    _use_threaded_mul[] = true
    return
end

function __init__()
    return set_num_threads(Base.Threads.nthreads())
end

include("linalg.jl")
include("mapreduce.jl")
include("broadcast.jl")
include("macros.jl")
include("convert.jl")

include("precompile.jl")

end

# linear algebra
LinearAlgebra.rmul!(dst::StridedView, α::Number) = mul!(dst, dst, α)
LinearAlgebra.lmul!(α::Number, dst::StridedView) = mul!(dst, α, dst)

function LinearAlgebra.mul!(
        dst::StridedView{<:Number, N}, α::Number,
        src::StridedView{<:Number, N}
    ) where {N}
    if α == 1
        copy!(dst, src)
    else
        dst .= α .* src
    end
    return dst
end
function LinearAlgebra.mul!(
        dst::StridedView{<:Number, N}, src::StridedView{<:Number, N},
        α::Number
    ) where {N}
    if α == 1
        copy!(dst, src)
    else
        dst .= src .* α
    end
    return dst
end
function LinearAlgebra.axpy!(
        a::Number, X::StridedView{<:Number, N},
        Y::StridedView{<:Number, N}
    ) where {N}
    if a == 1
        Y .= X .+ Y
    else
        Y .= a .* X .+ Y
    end
    return Y
end
function LinearAlgebra.axpby!(
        a::Number, X::StridedView{<:Number, N},
        b::Number, Y::StridedView{<:Number, N}
    ) where {N}
    if b == 1
        axpy!(a, X, Y)
    elseif b == 0
        mul!(Y, a, X)
    else
        Y .= a .* X .+ b .* Y
    end
    return Y
end

function LinearAlgebra.mul!(
        C::StridedView{T, 2},
        A::StridedView{<:Any, 2}, B::StridedView{<:Any, 2},
        α::Number = true, β::Number = false
    ) where {T}
    if !(eltype(C) <: LinearAlgebra.BlasFloat && eltype(A) == eltype(B) == eltype(C))
        return __mul!(C, A, B, α, β)
    end
    # C.op is identity or conj
    if C.op == conj
        if stride(C, 1) < stride(C, 2)
            _mul!(conj(C), conj(A), conj(B), conj(α), conj(β))
        else
            _mul!(C', B', A', conj(α), conj(β))
        end
    elseif stride(C, 1) > stride(C, 2)
        _mul!(transpose(C), transpose(B), transpose(A), α, β)
    else
        _mul!(C, A, B, α, β)
    end
    return C
end

function isblasmatrix(A::StridedView{T, 2}) where {T <: LinearAlgebra.BlasFloat}
    pointer(A) isa Ptr || return false
    if A.op == identity
        return stride(A, 1) == 1 || stride(A, 2) == 1
    elseif A.op == conj
        return stride(A, 2) == 1
    else # should never happen
        return false
    end
end
function getblasmatrix(A::StridedView{T, 2}) where {T <: LinearAlgebra.BlasFloat}
    if A.op == identity
        if stride(A, 1) == 1
            return A, 'N'
        else
            return transpose(A), 'T'
        end
    else
        return adjoint(A), 'C'
    end
end

# here we will have C.op == :identity && stride(C,1) < stride(C,2)
function _mul!(
        C::StridedView{T, 2}, A::StridedView{T, 2}, B::StridedView{T, 2},
        α::Number, β::Number
    ) where {T <: LinearAlgebra.BlasFloat}
    if stride(C, 1) == 1 && isblasmatrix(A) && isblasmatrix(B)
        return blas_mul!(C, A, B, α, β)
    else
        return __mul!(C, A, B, α, β)
    end
end

# for CPU based arrays, this is valid
function blas_mul!(
        C::StridedView{T, 2}, A::StridedView{T, 2}, B::StridedView{T, 2},
        α::Number, β::Number
    ) where {T <: LinearAlgebra.BlasFloat}
    m, n = size(C)
    m == size(A, 1) && n == size(B, 2) || throw(DimensionMismatch())
    nthreads = use_threaded_mul() ? get_num_threads() : 1
    A2, CA = getblasmatrix(A)
    B2, CB = getblasmatrix(B)
    return _threaded_blas_mul!(C, A2, CA, B2, CB, convert(T, α), convert(T, β), nthreads)
end

_split_row(A, m) = (A[1:m, :], A[(m + 1):end, :])
_split_col(A, m) = (A[:, 1:m], A[:, (m + 1):end])

function _threaded_blas_mul!(
        C::StridedView{T, 2},
        A::StridedView{T, 2}, CA,
        B::StridedView{T, 2}, CB,
        α::Number, β::Number,
        nthreads
    ) where {T <: LinearAlgebra.BlasFloat}
    m, n = size(C)
    if nthreads == 1 || m * n < 1024
        LinearAlgebra.BLAS.gemm!(CA, CB, α, A, B, β, C)
        return C
    end

    if m > n
        m2 = round(Int, m / 16) * 8
        Chead, Ctail = _split_row(C, m2)
        Ahead, Atail = CA == 'N' ? _split_row(A, m2) : _split_col(A, m2)
        Bhead = Btail = B
    else
        n2 = round(Int, n / 16) * 8
        Chead, Ctail = _split_col(C, n2)
        Ahead = Atail = A
        Bhead, Btail = CB == 'N' ? _split_col(B, n2) : _split_row(B, n2)
    end
    nthreads1 = nthreads >> 1
    nthreads2 = nthreads - nthreads1
    t = Threads.@spawn _threaded_blas_mul!(Chead, Ahead, CA, Bhead, CB, α, β, nthreads1)
    _threaded_blas_mul!(Ctail, Atail, CA, Btail, CB, α, β, nthreads2)
    wait(t)
    return C
end

# This implementation is faster than LinearAlgebra.generic_matmatmul
function __mul!(
        C::StridedView{<:Any, 2}, A::StridedView{<:Any, 2}, B::StridedView{<:Any, 2},
        α::Number, β::Number
    )
    (size(C, 1) == size(A, 1) && size(C, 2) == size(B, 2) && size(A, 2) == size(B, 1)) ||
        throw(DimensionMismatch("A has size $(size(A)), B has size $(size(B)), C has size $(size(C))"))

    m, n = size(C)
    k = size(A, 2)
    A2 = sreshape(A, (m, 1, k))
    B2 = sreshape(permutedims(B, (2, 1)), (1, n, k))
    C2 = sreshape(C, (m, n, 1))

    if α == 0 || k == 0
        rmul!(C, β)
    elseif α == 1
        if β == 0
            _mapreducedim!(*, +, zero, (m, n, k), (C2, A2, B2))
        elseif β == 1
            _mapreducedim!(*, +, nothing, (m, n, k), (C2, A2, B2))
        else
            _mapreducedim!(*, +, x -> x * β, (m, n, k), (C2, A2, B2))
        end
    else
        f = (x, y) -> (x * y * α)
        if β == 0
            _mapreducedim!(f, +, zero, (m, n, k), (C2, A2, B2))
        elseif β == 1
            _mapreducedim!(f, +, nothing, (m, n, k), (C2, A2, B2))
        else
            _mapreducedim!(f, +, x -> x * β, (m, n, k), (C2, A2, B2))
        end
    end
    return C
end

@testset "in-place matrix operations" begin
    @testset for T in (Float32, Float64, ComplexF32, ComplexF64)
        A1 = randn(T, (1000, 1000))
        A2 = similar(A1)
        A1c = copy(A1)
        A2c = copy(A2)
        B1 = StridedView(A1c)
        B2 = StridedView(A2c)

        @test conj!(A1) == conj!(B1)
        @test adjoint!(A2, A1) == adjoint!(B2, B1)
        @test transpose!(A2, A1) == transpose!(B2, B1)
        @test permutedims!(A2, A1, (2, 1)) == permutedims!(B2, B1, (2, 1))
    end
end

@testset "map, scale!, axpy! and axpby! with StridedView" begin
    @testset for T in (Float32, Float64, ComplexF32, ComplexF64)
        @testset for N in 2:6
            dims = ntuple(n -> div(60, N), N)
            R1, R2, R3 = rand(T, dims), rand(T, dims), rand(T, dims)
            B1 = permutedims(StridedView(R1), randperm(N))
            B2 = permutedims(StridedView(R2), randperm(N))
            B3 = permutedims(StridedView(R3), randperm(N))
            A1 = convert(Array, B1)
            A2 = convert(Array{T}, B2) # test different converts
            A3 = convert(Array{T,N}, B3)
            C1 = deepcopy(B1)

            @test rmul!(B1, 1 // 2) ≈ rmul!(A1, 1 // 2)
            @test lmul!(1 // 3, B2) ≈ lmul!(1 // 3, A2)
            @test axpy!(1 // 3, B1, B2) ≈ axpy!(1 // 3, A1, A2)
            @test axpy!(1, B2, B3) ≈ axpy!(1, A2, A3)
            @test axpby!(1 // 3, B1, 1 // 2, B3) ≈ axpby!(1 // 3, A1, 1 // 2, A3)
            @test axpby!(1, B2, 1, B1) ≈ axpby!(1, A2, 1, A1)
            @test map((x, y, z) -> sin(x) + y / exp(-abs(z)), B1, B2, B3) ≈
                  map((x, y, z) -> sin(x) + y / exp(-abs(z)), A1, A2, A3)
            @test map((x, y, z) -> sin(x) + y / exp(-abs(z)), B1, B2, B3) isa StridedView
            @test map((x, y, z) -> sin(x) + y / exp(-abs(z)), B1, A2, B3) isa Array
            @test mul!(B1, 1, B2) ≈ mul!(A1, 1, A2)
            @test mul!(B1, B2, 1) ≈ mul!(A1, A2, 1)
        end
    end
end

@testset "broadcast with StridedView" begin
    @testset for T in (Float32, Float64, ComplexF32, ComplexF64)
        R1, R2, R3 = rand(T, (10,)), rand(T, (10, 10)), rand(T, (10, 10, 10))
        B1 = StridedView(R1)
        B2 = permutedims(StridedView(R2), randperm(2))
        B3 = permutedims(StridedView(R3), randperm(3))
        A1 = convert(Array, B1)
        A2 = convert(Array{T}, B2)
        A3 = convert(Array{T,3}, B3)

        @test @inferred(B1 .+ sin.(B2 .- 3)) ≈ A1 .+ sin.(A2 .- 3)
        @test @inferred(B2' .* B3 .- Ref(0.5)) ≈ A2' .* A3 .- Ref(0.5)
        @test @inferred(B2' .* B3 .- max.(abs.(B1), real.(B3))) ≈
              A2' .* A3 .- max.(abs.(A1), real.(A3))

        @test (B1 .+ sin.(B2 .- 3)) isa StridedView
        @test (B2' .* B3 .- Ref(0.5)) isa StridedView
        @test (B2' .* B3 .- max.(abs.(B1), real.(B3))) isa StridedView
        @test (B2' .* A3 .- max.(abs.(B1), real.(B3))) isa Array
    end
end

@testset "mapreduce with StridedView" begin
    @testset for T in (Float32, Float64, ComplexF32, ComplexF64)
        R1 = rand(T, (10, 10, 10, 10, 10, 10))
        @test sum(R1; dims=(1, 3, 5)) ≈ sum(StridedView(R1); dims=(1, 3, 5))
        @test mapreduce(sin, +, R1; dims=(1, 3, 5)) ≈
              mapreduce(sin, +, StridedView(R1); dims=(1, 3, 5))
        R2 = rand(T, (10, 10, 10))
        R2c = copy(R2)
        @test Strided._mapreducedim!(sin, +, identity, (10, 10, 10, 10, 10, 10),
                                     (sreshape(StridedView(R2c), (10, 1, 1, 10, 10, 1)),
                                      StridedView(R1))) ≈
              mapreduce(sin, +, R1; dims=(2, 3, 6)) .+ reshape(R2, (10, 1, 1, 10, 10, 1))
        R2c = copy(R2)
        @test Strided._mapreducedim!(sin, +, x -> 0, (10, 10, 10, 10, 10, 10),
                                     (sreshape(StridedView(R2c), (10, 1, 1, 10, 10, 1)),
                                      StridedView(R1))) ≈
              mapreduce(sin, +, R1; dims=(2, 3, 6))
        R2c = copy(R2)
        β = rand(T)
        @test Strided._mapreducedim!(sin, +, x -> β * x, (10, 10, 10, 10, 10, 10),
                                     (sreshape(StridedView(R2c), (10, 1, 1, 10, 10, 1)),
                                      StridedView(R1))) ≈
              mapreduce(sin, +, R1; dims=(2, 3, 6)) .+
              β .* reshape(R2, (10, 1, 1, 10, 10, 1))
        R2c = copy(R2)
        @test Strided._mapreducedim!(sin, +, x -> β, (10, 10, 10, 10, 10, 10),
                                     (sreshape(StridedView(R2c), (10, 1, 1, 10, 10, 1)),
                                      StridedView(R1))) ≈
              mapreduce(sin, +, R1; dims=(2, 3, 6), init=β)
        R2c = copy(R2)
        @test Strided._mapreducedim!(sin, +, conj, (10, 10, 10, 10, 10, 10),
                                     (sreshape(StridedView(R2c), (10, 1, 1, 10, 10, 1)),
                                      StridedView(R1))) ≈
              mapreduce(sin, +, R1; dims=(2, 3, 6)) .+
              conj.(reshape(R2, (10, 1, 1, 10, 10, 1)))

        R3 = rand(T, (100, 100, 2))
        @test sum(R3; dims=(1, 2)) ≈ sum(StridedView(R3); dims=(1, 2))
    end
end

@testset "complete reductions with StridedView" begin
    @testset for T in (Float32, Float64, ComplexF32, ComplexF64)
        R1 = rand(T, (10, 10, 10, 10, 10, 10))

        @test sum(R1) ≈ sum(StridedView(R1))
        @test maximum(abs, R1) ≈ maximum(abs, StridedView(R1))
        @test minimum(real, R1) ≈ minimum(real, StridedView(R1))
        @test sum(x -> real(x) < 0, R1) == sum(x -> real(x) < 0, StridedView(R1))

        R2 = PermutedDimsArray(R1, (randperm(6)...,))

        @test sum(R2) ≈ sum(StridedView(R2))
        @test maximum(abs, R2) ≈ maximum(abs, StridedView(R2))
        @test minimum(real, R2) ≈ minimum(real, StridedView(R2))
        @test sum(x -> real(x) < 0, R1) == sum(x -> real(x) < 0, StridedView(R2))

        R3 = rand(T, (5, 5, 5))
        @test prod(exp, StridedView(R3)) ≈ exp(sum(StridedView(R3)))
    end
end

@testset "@strided macro" begin
    @testset for T in (Float32, Float64, ComplexF32, ComplexF64)
        A1, A2, A3 = rand(T, (10,)), rand(T, (10, 10)), rand(T, (10, 10, 10))

        @test (@strided(@. A1 + sin(A2 - 3))) isa StridedView
        @test (@strided(A1 .+ sin.(A2 .- 3))) isa StridedView
        @test (@strided(A1 .+ sin.(A2 .- 3))) ≈ A1 .+ sin.(A2 .- 3)
        @test (@strided(A2' .* A3 .- Ref(0.5))) ≈ A2' .* A3 .- Ref(0.5)
        @test (@strided(A2' .* A3 .- max.(abs.(A1), real.(A3)))) ≈
              A2' .* A3 .- max.(abs.(A1), real.(A3))

        B2 = view(A2, :, 1:2:10)
        @test (@strided(A1 .+ sin.(view(A2, :, 1:2:10) .- 3))) ≈
              (@strided(A1 .+ sin.(B2 .- 3))) ≈
              A1 .+ sin.(view(A2, :, 1:2:10) .- 3)

        B2 = view(A2', :, 1:6)
        B3 = view(A3, :, 1:6, 4)
        @test (@strided(view(A2', :, 1:6) .* view(A3, :, 1:6, 4) .- Ref(0.5))) ≈
              (@strided(B2 .* B3 .- Ref(0.5))) ≈
              view(A2', :, 1:6) .* view(A3, :, 1:6, 4) .- Ref(0.5)

        B2 = view(A2, :, 3)
        B3 = view(A3, 1:5, :, 2:2:10)
        B1 = view(A1, 1:5)
        B3b = view(A3, 4:4, 4:4, 2:2:10)
        @test (@strided(view(A2, :, 3)' .* view(A3, 1:5, :, 2:2:10) .-
                        max.(abs.(view(A1, 1:5)), real.(view(A3, 4:4, 4:4, 2:2:10))))) ≈
              (@strided(B2' .* B3 .- max.(abs.(B1), real.(B3b)))) ≈
              view(A2, :, 3)' .* view(A3, 1:5, :, 2:2:10) .-
              max.(abs.(view(A1, 1:5)), real.(view(A3, 4:4, 4:4, 2:2:10)))

        B2 = reshape(A2, (10, 2, 5))
        @test (@strided(A1 .+ sin.(reshape(A2, (10, 2, 5)) .- 3))) ≈
              (@strided(A1 .+ sin.(B2 .- 3))) ≈
              A1 .+ sin.(reshape(A2, (10, 2, 5)) .- 3)

        B2 = reshape(A2, 1, 100)
        B3 = reshape(A3, 100, 1, 10)
        @test (@strided(reshape(A2, 1, 100)' .* reshape(A3, 100, 1, 10) .- Ref(0.5))) ≈
              (@strided(B2' .* B3 .- Ref(0.5))) ≈
              reshape(A2, 1, 100)' .* reshape(A3, 100, 1, 10) .- Ref(0.5)

        B2 = view(A2, :, 3)
        B3 = reshape(view(A3, 1:5, :, :), 5, 10, 5, 2)
        B1 = view(A1, 1:5)
        B3b = view(A3, 4:4, 4:4, 2:2:10)
        @test (@strided(view(A2, :, 3)' .* reshape(view(A3, 1:5, :, :), 5, 10, 5, 2) .-
                        max.(abs.(view(A1, 1:5)), real.(view(A3, 4:4, 4:4, 2:2:10))))) ≈
              (@strided(B2' .* B3 .- max.(abs.(B1), real.(B3b)))) ≈
              view(A2, :, 3)' .* reshape(view(A3, 1:5, :, :), 5, 10, 5, 2) .-
              max.(abs.(view(A1, 1:5)), real.(view(A3, 4:4, 4:4, 2:2:10)))

        x = @strided begin
            p = :A => A1
            f = pair -> (pair.first, pair.second)
            f(p)
        end
        @test x[2] === parent(StridedView(A1))
    end
end

@testset "@unsafe_strided macro" begin
    @testset for T in (Float32, Float64, ComplexF32, ComplexF64)
        A1, A2, A3 = rand(T, (10,)), rand(T, (10, 10)), rand(T, (10, 10, 10))

        @test (@unsafe_strided(A1, A2, @. A1 + sin(A2 - 3))) isa StridedView
        @test (@unsafe_strided(A1, A2, A1 .+ sin.(A2 .- 3))) isa StridedView

        @test (@unsafe_strided(A1, A2, A1 .+ sin.(A2 .- 3))) ≈ A1 .+ sin.(A2 .- 3)
        @test (@unsafe_strided(A2, A3, A2' .* A3 .- Ref(0.5))) ≈ A2' .* A3 .- Ref(0.5)
        @test (@unsafe_strided(A1, A2, A3, A2' .* A3 .- max.(abs.(A1), real.(A3)))) ≈
              A2' .* A3 .- max.(abs.(A1), real.(A3))

        B2 = view(A2, :, 1:2:10)
        @test (@unsafe_strided(A1, A2, A1 .+ sin.(view(A2, :, 1:2:10) .- 3))) ≈
              (@unsafe_strided(A1, B2, A1 .+ sin.(B2 .- 3))) ≈
              A1 .+ sin.(view(A2, :, 1:2:10) .- 3)

        B2 = view(A2', :, 1:6)
        B3 = view(A3, :, 1:6, 4)
        @test (@unsafe_strided(A2, A3,
                               view(A2', :, 1:6) .* view(A3, :, 1:6, 4) .- Ref(0.5))) ≈
              (@unsafe_strided(B2, B3, B2 .* B3 .- Ref(0.5))) ≈
              view(A2', :, 1:6) .* view(A3, :, 1:6, 4) .- Ref(0.5)

        B2 = view(A2, :, 3)
        B3 = view(A3, 1:5, :, 2:2:10)
        B1 = view(A1, 1:5)
        B3b = view(A3, 4:4, 4:4, 2:2:10)
        @test (@unsafe_strided(A1, A2, A3,
                               view(A2, :, 3)' .* view(A3, 1:5, :, 2:2:10) .-
                               max.(abs.(view(A1, 1:5)), real.(view(A3, 4:4, 4:4, 2:2:10))))) ≈
              (@unsafe_strided(B1, B2, B3, B2' .* B3 .- max.(abs.(B1), real.(B3b)))) ≈
              view(A2, :, 3)' .* view(A3, 1:5, :, 2:2:10) .-
              max.(abs.(view(A1, 1:5)), real.(view(A3, 4:4, 4:4, 2:2:10)))

        B2 = reshape(A2, (10, 2, 5))
        @test (@unsafe_strided(A1, A2, A1 .+ sin.(reshape(A2, (10, 2, 5)) .- 3))) ≈
              (@unsafe_strided(A1, B2, A1 .+ sin.(B2 .- 3))) ≈
              A1 .+ sin.(reshape(A2, (10, 2, 5)) .- 3)

        B2 = reshape(A2, 1, 100)
        B3 = reshape(A3, 100, 1, 10)
        @test (@unsafe_strided(A2, A3,
                               reshape(A2, 1, 100)' .* reshape(A3, 100, 1, 10) .- Ref(0.5))) ≈
              (@unsafe_strided(B2, B3, B2' .* B3 .- Ref(0.5))) ≈
              reshape(A2, 1, 100)' .* reshape(A3, 100, 1, 10) .- Ref(0.5)

        B2 = view(A2, :, 3)
        B3 = reshape(view(A3, 1:5, :, :), 5, 10, 5, 2)
        B1 = view(A1, 1:5)
        B3b = view(A3, 4:4, 4:4, 2:2:10)
        @test (@unsafe_strided(A1, A2, A3,
                               view(A2, :, 3)' .*
                               reshape(view(A3, 1:5, :, :), 5, 10, 5, 2) .-
                               max.(abs.(view(A1, 1:5)), real.(view(A3, 4:4, 4:4, 2:2:10))))) ≈
              (@unsafe_strided(B1, B2, B3, B2' .* B3 .- max.(abs.(B1), real.(B3b)))) ≈
              view(A2, :, 3)' .* reshape(view(A3, 1:5, :, :), 5, 10, 5, 2) .-
              max.(abs.(view(A1, 1:5)), real.(view(A3, 4:4, 4:4, 2:2:10)))
    end
end

@testset "multiplication with StridedView: Complex{Int}" begin
    d = 103
    A1 = map(complex, rand(-100:100, (d, d)), rand(-100:100, (d, d)))
    A2 = map(complex, rand(-100:100, (d, d)), rand(-100:100, (d, d)))
    A3 = map(complex, rand(-100:100, (d, d)), rand(-100:100, (d, d)))
    A4 = map(complex, rand(-100:100, (d, d)), rand(-100:100, (d, d)))
    A1c = copy(A1)
    A2c = copy(A2)
    A3c = copy(A3)
    A4c = copy(A4)
    B1 = StridedView(A1c)
    B2 = StridedView(A2c)
    B3 = StridedView(A3c)
    B4 = StridedView(A4c)

    for op1 in (identity, conj, transpose, adjoint)
        @test op1(A1) == op1(B1)
        for op2 in (identity, conj, transpose, adjoint)
            @test op1(A1) * op2(A2) ≈ op1(B1) * op2(B2)
            for op3 in (identity, conj, transpose, adjoint)
                α = 2 + im
                β = 3 - im
                copy!(B3, B4)
                mul!(op3(B3), op1(B1), op2(B2), α, β)
                @test B3 ≈ op3(β) * A4 + op3(α * op1(A1) * op2(A2)) # op3 is its own inverse
                copy!(B3, B4)
                mul!(op3(B3), op1(B1), op2(B2), α, 0)
                @test B3 ≈ op3(α * op1(A1) * op2(A2)) # op3 is its own inverse
                copy!(B3, B4)
                mul!(op3(B3), op1(B1), op2(B2))
                @test B3 ≈ op3(op1(A1) * op2(A2)) # op3 is its own inverse
            end
        end
    end

    A = map(complex, rand(-100:100, (2, 0)), rand(-100:100, (2, 0)))
    B = map(complex, rand(-100:100, (0, 2)), rand(-100:100, (0, 2)))
    C = map(complex, rand(-100:100, (2, 2)), rand(-100:100, (2, 2)))
    α = complex(rand(-100:100), rand(-100:100))
    β = one(eltype(C))
    A1 = StridedView(copy(A))
    B1 = StridedView(copy(B))
    C1 = StridedView(copy(C))
    @test mul!(C, A, B, α, β) ≈ mul!(C1, A1, B1, α, β)
end

@testset "multiplication with StridedView: Rational{Int}" begin
    d = 103
    A1 = map(//, rand(-10:10, (d, d)), rand(1:10, (d, d)))
    A2 = map(//, rand(-10:10, (d, d)), rand(1:10, (d, d)))
    A3 = map(//, rand(-10:10, (d, d)), rand(1:10, (d, d)))
    A4 = map(//, rand(-10:10, (d, d)), rand(1:10, (d, d)))
    A1c = copy(A1)
    A2c = copy(A2)
    A3c = copy(A3)
    A4c = copy(A4)
    B1 = StridedView(A1c)
    B2 = StridedView(A2c)
    B3 = StridedView(A3c)
    B4 = StridedView(A4c)

    for op1 in (identity, conj, transpose, adjoint)
        @test op1(A1) == op1(B1)
        for op2 in (identity, conj, transpose, adjoint)
            @test op1(A1) * op2(A2) ≈ op1(B1) * op2(B2)
            for op3 in (identity, conj, transpose, adjoint)
                α = 1 // 2
                β = 3 // 2
                copy!(B3, B4)
                mul!(op3(B3), op1(B1), op2(B2), α, β)
                @test B3 ≈ op3(β) * A4 + op3(α * op1(A1) * op2(A2)) # op3 is its own inverse
                copy!(B3, B4)
                mul!(op3(B3), op1(B1), op2(B2), α, 1)
                @test B3 ≈ A4 + op3(α * op1(A1) * op2(A2)) # op3 is its own inverse
                copy!(B3, B4)
                mul!(op3(B3), op1(B1), op2(B2), 1, 1)
                @test B3 ≈ A4 + op3(op1(A1) * op2(A2)) # op3 is its own inverse
            end
        end
    end
end

using Revise
using LinearAlgebra
using BenchmarkTools
using Strided
using TensorOperations
using Tullio
using LoopVectorization

sizes = ceil.(Int, 2 .^ (2:1.5:20))

function benchmark_sum(sizes)
    times = zeros(length(sizes), 3)
    for (i, s) in enumerate(sizes)
        A = randn(Float64, s)
        times[i, 1] = @belapsed sum($A)
        Strided.disable_threads()
        times[i, 2] = @belapsed @strided sum($A)
        Strided.enable_threads()
        times[i, 3] = @belapsed @strided sum($A)
        println("step $i: size $s => times = $(times[i, :])")
    end
    return times
end

function benchmark_permute(sizes, p=(4, 3, 2, 1))
    times = zeros(length(sizes), 4)
    for (i, s) in enumerate(sizes)
        A = randn(Float64, s .* one.(p))
        B = similar(A)
        times[i, 1] = @belapsed copy!($B, $A)
        times[i, 2] = @belapsed permutedims!($B, $A, $p)
        Strided.disable_threads()
        times[i, 3] = @belapsed @strided permutedims!($B, $A, $p)
        Strided.enable_threads()
        times[i, 4] = @belapsed @strided permutedims!($B, $A, $p)
        println("step $i: size $s => times = $(times[i, :])")
    end
    return times
end
permute_times1 = benchmark_permute(sizes, (4, 3, 2, 1))
permute_times2 = benchmark_permute(sizes, (2, 3, 4, 1))
permute_times3 = benchmark_permute(sizes, (3, 4, 1, 2))

function benchmark_mul(sizesm, sizesk=sizesm, sizesn=sizesm)
    N = Threads.nthreads()
    @assert length(sizesm) == length(sizesk) == length(sizesn)
    times = zeros(length(sizesm), 4)
    @inbounds for i in 1:length(sizesm)
        m = sizesm[i]
        k = sizesk[i]
        n = sizesn[i]
        A = randn(Float64, (m, k))
        B = randn(Float64, (k, n))
        C = randn(Float64, (m, n))

        BLAS.set_num_threads(1) # base case: single-threaded blas
        times[i, 1] = @belapsed mul!($C, $A, $B)
        BLAS.set_num_threads(N) # multithreaded blas
        times[i, 2] = @belapsed mul!($C, $A, $B)
        Strided.disable_threaded_mul() # same, except for small overhead from strided
        times[i, 3] = @belapsed @strided mul!($C, $A, $B)
        BLAS.set_num_threads(1) # single-threaded blas with strided multithreading
        Strided.enable_threaded_mul()
        times[i, 4] = @belapsed @strided mul!($C, $A, $B)
        println("step $i: sizes $((m,k,n)) => times = $(times[i, :])")
    end
    return times
end

function tensorcontraction!(wEnv, hamAB, hamBA, rhoBA, rhoAB, w, v, u)
    @tensor wEnv[-1, -2, -3] = hamAB[7, 8, -1, 9] * rhoBA[4, 3, -3, 2] * conj(w[7, 5, 4]) *
                               u[9, 10, -2, 11] * conj(u[8, 10, 5, 6]) * v[1, 11, 2] *
                               conj(v[1, 6, 3]) +
                               hamBA[1, 2, 3, 4] * rhoBA[10, 7, -3, 6] *
                               conj(w[-1, 11, 10]) * u[3, 4, -2, 8] * conj(u[1, 2, 11, 9]) *
                               v[5, 8, 6] * conj(v[5, 9, 7]) +
                               hamAB[5, 7, 3, 1] * rhoBA[10, 9, -3, 8] *
                               conj(w[-1, 11, 10]) * u[4, 3, -2, 2] * conj(u[4, 5, 11, 6]) *
                               v[1, 2, 8] * conj(v[7, 6, 9]) +
                               hamBA[3, 7, 2, -1] * rhoAB[5, 6, 4, -3] * v[2, 1, 4] *
                               conj(v[3, 1, 5]) * conj(w[7, -2, 6])
    return wEnv
end

function benchmark_tensorcontraction(sizes)
    N = Threads.nthreads()
    times = zeros(length(sizes), 5)
    @inbounds for (i, s) in enumerate(sizes)
        hamAB = randn(Float64, (s, s, s, s))
        hamBA = randn(Float64, (s, s, s, s))
        rhoAB = randn(Float64, (s, s, s, s))
        rhoBA = randn(Float64, (s, s, s, s))
        v = randn(Float64, (s, s, s))
        w = randn(Float64, (s, s, s))
        u = randn(Float64, (s, s, s, s))
        wEnv = randn(Float64, (s, s, s))

        tensorcontraction!(wEnv, hamAB, hamBA, rhoBA, rhoAB, w, v, u)

        BLAS.set_num_threads(1)
        Strided.disable_threads()
        Strided.disable_threaded_mul()
        times[i, 1] = @belapsed tensorcontraction!($wEnv, $hamAB, $hamBA, $rhoBA, $rhoAB,
                                                   $w, $v, $u)

        BLAS.set_num_threads(1)
        Strided.enable_threads()
        Strided.disable_threaded_mul()
        times[i, 2] = @belapsed tensorcontraction!($wEnv, $hamAB, $hamBA, $rhoBA, $rhoAB,
                                                   $w, $v, $u)

        BLAS.set_num_threads(N)
        Strided.disable_threads()
        Strided.disable_threaded_mul()
        times[i, 3] = @belapsed tensorcontraction!($wEnv, $hamAB, $hamBA, $rhoBA, $rhoAB,
                                                   $w, $v, $u)

        BLAS.set_num_threads(N)
        Strided.enable_threads()
        Strided.disable_threaded_mul()
        times[i, 4] = @belapsed tensorcontraction!($wEnv, $hamAB, $hamBA, $rhoBA, $rhoAB,
                                                   $w, $v, $u)

        BLAS.set_num_threads(1)
        Strided.enable_threads()
        Strided.enable_threaded_mul()
        times[i, 5] = @belapsed tensorcontraction!($wEnv, $hamAB, $hamBA, $rhoBA, $rhoAB,
                                                   $w, $v, $u)

        println("step $i: size $s => times = $(times[i, :])")
    end
    return times
end

using Test
using LinearAlgebra
using Random
using Strided
using Strided: StridedView
using Aqua
using Adapt, GPUArrays
using JLArrays
using AMDGPU
using CUDACore, cuRAND, cuBLAS
using Metal

Random.seed!(1234)

is_buildkite = get(ENV, "BUILDKITE", "false") == "true"

if !is_buildkite
    println("Base.Threads.nthreads() =  $(Base.Threads.nthreads())")

    println("Running tests single-threaded:")
    Strided.disable_threads()
    include("othertests.jl")
    include("blasmultests.jl")

    if Base.Threads.nthreads() > 1
        println("Running tests multi-threaded:")
        Strided.enable_threads()
        Strided.set_num_threads(Base.Threads.nthreads() + 1)
        include("othertests.jl")
        include("blasmultests.jl")

        Strided.enable_threaded_mul()
        include("blasmultests.jl")
        Strided.disable_threaded_mul()
    else
        @warn "Cannot run multi-threaded tests"
    end

    Aqua.test_all(Strided; piracies = false)
end

include("gpu.jl")

using Base.Broadcast: BroadcastStyle, AbstractArrayStyle, DefaultArrayStyle, Broadcasted

struct StridedArrayStyle{N} <: AbstractArrayStyle{N}
end

Broadcast.BroadcastStyle(::Type{<:StridedView{<:Any, N}}) where {N} = StridedArrayStyle{N}()

StridedArrayStyle(::Val{N}) where {N} = StridedArrayStyle{N}()
StridedArrayStyle{M}(::Val{N}) where {M, N} = StridedArrayStyle{N}()

Broadcast.BroadcastStyle(a::StridedArrayStyle, ::DefaultArrayStyle{0}) = a
function Broadcast.BroadcastStyle(::StridedArrayStyle{N}, a::DefaultArrayStyle) where {N}
    return BroadcastStyle(DefaultArrayStyle{N}(), a)
end
function Broadcast.BroadcastStyle(
        ::StridedArrayStyle{N},
        ::Broadcast.Style{Tuple}
    ) where {N}
    return DefaultArrayStyle{N}()
end

function Base.similar(bc::Broadcasted{<:StridedArrayStyle{N}}, ::Type{T}) where {N, T}
    sv = _find_strided_view(bc)
    if sv !== nothing
        return StridedView(similar(parent(sv), T, size(bc)))
    end
    return StridedView(similar(Array{T}, axes(bc)))
end

@inline _find_strided_view(bc::Broadcasted) = _find_strided_view(bc.args...)
@inline _find_strided_view(sv::StridedView, rest...) = sv
@inline function _find_strided_view(nested::Broadcasted, rest...)
    sv = _find_strided_view(nested)
    return sv === nothing ? _find_strided_view(rest...) : sv
end
@inline _find_strided_view(x, rest...) = _find_strided_view(rest...)
@inline _find_strided_view() = nothing

Base.dotview(a::StridedView{<:Any, N}, I::Vararg{SliceIndex, N}) where {N} = getindex(a, I...)

# Broadcasting implementation
@inline function Base.copyto!(
        dest::StridedView{<:Any, N},
        bc::Broadcasted{StridedArrayStyle{N}}
    ) where {N}
    dims = size(dest)
    any(isequal(0), dims) && return dest

    # convert to map

    # flatten and only keep the StridedView arguments
    # promote StridedView to have same size, by giving artificial zero strides
    stridedargs = promoteshape(dims, capturestridedargs(bc)...)
    c = make_capture(bc)
    _mapreduce_order!(c, nothing, nothing, dims, (dest, stridedargs...))
    return dest
end

const WrappedScalarArgs = Union{AbstractArray{<:Any, 0}, Ref{<:Any}}

@inline function capturestridedargs(t::Broadcasted, rest...)
    return (capturestridedargs(t.args...)..., capturestridedargs(rest...)...)
end
@inline capturestridedargs(t::StridedView, rest...) = (t, capturestridedargs(rest...)...)
@inline capturestridedargs(t, rest...) = capturestridedargs(rest...)
@inline capturestridedargs() = ()

# broadcast by promoting size 1 dimensions to full size
# making the stride in that dimension zero
function promoteshape(sz::Dims, a1::StridedView, As...)
    return (promoteshape1(sz, a1), promoteshape(sz, As...)...)
end
promoteshape(sz::Dims) = ()
function promoteshape1(sz::Dims{N}, a::StridedView) where {N}
    newstrides = ntuple(Val(N)) do d
        if size(a, d) == sz[d]
            stride(a, d)
        elseif size(a, d) == 1
            0
        else
            throw(DimensionMismatch("array could not be broadcasted to match destination"))
        end
    end
    return StridedView(a.parent, sz, newstrides, a.offset, a.op)
end

struct CaptureArgs{F, Args <: Tuple}
    f::F
    args::Args
end
struct Arg
end

# construct CaptureArgs
@inline function make_capture(bc::Broadcasted)
    args = make_tcapture(bc.args)
    return CaptureArgs(bc.f, args)
end
@inline make_tcapture(t::Tuple{}) = t
@inline make_tcapture(t::Tuple) = (make_capture(t[1]), make_tcapture(tail(t))...)
@inline make_capture(a::WrappedScalarArgs) = a[]
@inline make_capture(a::StridedView) = Arg()
@inline make_capture(a) = a

# Evaluate CaptureArgs
@inline (c::CaptureArgs)(vals...) = consume(c, vals)[1]
@inline function consume(c::CaptureArgs{F, Args}, vals) where {F, Args}
    args, newvals = t_consume(c.args, vals)
    return c.f(args...), newvals
end
@inline consume(a::Arg, vals::Tuple) = vals[1], tail(vals)
@inline consume(a, vals) = a, vals
@inline t_consume(t::Tuple{}, vals) = t, vals
@inline function t_consume(t::Tuple, vals)
    t1, newvals1 = consume(t[1], vals)
    ttail, newvals = t_consume(tail(t), newvals1)
    return (t1, ttail...), newvals
end

using PrecompileTools: @setup_workload, @compile_workload

@setup_workload begin
    Ts = [Float32, Float64, ComplexF32, ComplexF64]
    blasops = [identity, conj, transpose, adjoint]
    @compile_workload begin
        for T in Ts
            A = StridedView(zeros(T, 2, 2))
            B = StridedView(zeros(T, 2, 2))
            C = StridedView(zeros(T, 2, 2))
            # op variety on the operands, both scalar-argument forms
            for opA in blasops, opB in blasops
                mul!(C, opA(A), opB(B))
                mul!(C, opA(A), opB(B), one(T), zero(T))
            end
            # op variety on the destination (mul! normalization branches)
            for opC in (transpose, adjoint)
                mul!(opC(C), A, B)
                mul!(opC(C), A, B, one(T), zero(T))
            end
        end
    end
end

test_result(a::AbstractArray, b::AbstractArray; kwargs...) =
    isapprox(Array(a), Array(b); kwargs...)
test_result(a::Number, b::Number; kwargs...) = isapprox(a, b; kwargs...)

function compare(f, AT::Type, xs...; kwargs...)
    cpu_in = map(deepcopy, xs) # copy on CPU
    gpu_in = map(adapt(AT), xs) # adapt on GPU

    cpu_out = f(cpu_in...)
    gpu_out = f(gpu_in...)
    return test_result(cpu_out, gpu_out; kwargs...)
end

# types to test for
ATs = []
!is_buildkite && push!(ATs, JLArray)
CUDACore.functional() && cuBLAS.functional() && push!(ATs, CuArray)
AMDGPU.functional() && push!(ATs, ROCArray)
Metal.functional() && push!(ATs, MtlArray)

@testset "isblasmatrix ($AT)" for AT in ATs
    for T in (Float32, ComplexF32)
        A1 = StridedView(AT(randn(T, 20, 20)))
        @test Strided.isblasmatrix(A1)
        A2 = view(A1, 1:4:20, 1:5:20)
        @test !Strided.isblasmatrix(A2)
        A3 = view(conj!(A1), 1:4:20, 1:20) # stride(A3, 2) is not 1
        @test !Strided.isblasmatrix(A3)
    end
end

@testset "in-place matrix operations ($AT)" for AT in ATs
    for T in (Float32, ComplexF32)
        A1 = StridedView(randn(T, 20, 20))
        A2 = StridedView(randn(T, 20, 20))

        @test compare(conj!, AT, A1)
        @test compare(adjoint!, AT, A1, A2)
        @test compare(transpose!, AT, A1, A2)
        @test compare((x, y) -> permutedims!(x, y, (2, 1)), AT, A1, A2)

        B1 = A1[4:4:end, 1:4:end]
        B2 = A2[4:4:end, 1:4:end]

        @test compare(conj!, AT, B1)
        @test compare(adjoint!, AT, B1, B2)
        @test compare(transpose!, AT, B1, B2)
        @test compare((x, y) -> permutedims!(x, y, (2, 1)), AT, B1, B2)
    end
end

@testset "mul! ($AT{$T})" for AT in ATs, T in (Float32, ComplexF32)
    N = 2
    α = rand(T)
    β = rand(T)
    dims = ntuple(Returns(div(64, N)), N)
    A1 = permutedims(StridedView(rand(T, dims)), randperm(N))
    A2 = permutedims(StridedView(rand(T, dims)), randperm(N))
    A3 = permutedims(StridedView(rand(T, dims)), randperm(N))
    @test compare((C, A, B) -> mul!(C, A, B, α, β), AT, A1, A2, A3)
    # test BLAS for all op combinations
    @testset for sz in ((32, 64), (64, 64), (64, 32))
        vA1 = view(StridedView(rand(T, sz)), 1:32, 1:32)
        vA2 = view(StridedView(rand(T, sz)), 1:32, 1:32)
        vA3 = view(StridedView(rand(T, sz)), 1:32, 1:32)
        @testset for f1 in (identity, conj, adjoint, transpose), f2 in (identity, conj, adjoint, transpose)
            @test compare((C, A, B) -> mul!(C, A, B, α, β), AT, vA1, f1(vA2), f2(vA3))
        end
    end
    # non-BLAS fallback path
    vA1 = view(StridedView(rand(T, (32, 32))), 1:32, 1:32)
    vA2 = view(StridedView(rand(T, (32, 64))), 1:32, 1:2:64)
    vA3 = view(StridedView(rand(T, (64, 32))), 1:2:64, 1:32)
    @testset for f1 in (identity, conj, adjoint, transpose), f2 in (identity, conj, adjoint, transpose)
        @test compare((C, A, B) -> mul!(C, A, B, α, β), AT, vA1, f1(vA2), f2(vA3))
    end
    # non-BLAS fallback path
    vA1 = view(StridedView(rand(T, (64, 32))), 1:2:64, 1:32)
    vA2 = view(StridedView(rand(T, (32, 64))), 1:32, 1:2:64)
    vA3 = view(StridedView(rand(T, (64, 32))), 1:2:64, 1:32)
    @test compare((C, A, B) -> mul!(C, A, B, α, β), AT, vA1, vA2, vA3)
end

@testset "map, scale!, axpy!, axpby! ($AT)" for AT in ATs
    for T in (Float32, ComplexF32)
        for N in 2:6
            dims = ntuple(Returns(div(60, N)), N)
            A1 = permutedims(StridedView(rand(T, dims)), randperm(N))
            A2 = permutedims(StridedView(rand(T, dims)), randperm(N))
            A3 = permutedims(StridedView(rand(T, dims)), randperm(N))

            @test compare(x -> rmul!(x, 1 // 2), AT, A1)
            @test compare(x -> lmul!(1 // 3, x), AT, A2)
            @test compare((x, y) -> axpy!(1 // 3, x, y), AT, A1, A2)
            @test compare((x, y) -> axpby!(1 // 3, x, 1 // 2, y), AT, A1, A2)
            @test compare((x, y, z) -> map((a, b, c) -> sin(a) + b / exp(-abs(c)), x, y, z), AT, A1, A2, A3)
            @test compare((x, y) -> mul!(x, 1, y), AT, A1, A2)
            @test compare((x, y) -> mul!(x, y, 1), AT, A1, A2)
        end

        dims = ntuple(Returns(20), 2)
        A1 = permutedims(StridedView(rand(T, dims))[2:2:end, 2:2:end], randperm(2))
        A2 = permutedims(StridedView(rand(T, dims))[2:2:end, 2:2:end], randperm(2))
        A3 = permutedims(StridedView(rand(T, dims))[2:2:end, 2:2:end], randperm(2))
        @test compare(x -> rmul!(x, 1 // 2), AT, A1)
        @test compare(x -> lmul!(1 // 3, x), AT, A2)
        @test compare((x, y) -> axpy!(1 // 3, x, y), AT, A1, A2)
        @test compare((x, y) -> axpby!(1 // 3, x, 1 // 2, y), AT, A1, A2)
        @test compare((x, y, z) -> map((a, b, c) -> sin(a) + b / exp(-abs(c)), x, y, z), AT, A1, A2, A3)
        @test compare((x, y) -> mul!(x, 1, y), AT, A1, A2)
        @test compare((x, y) -> mul!(x, y, 1), AT, A1, A2)
    end
end

@testset "copy ($AT)" for AT in ATs
    N = 2
    for m1 in (0, 16, 32), m2 in (0, 16, 32), T in (Float32, ComplexF32)
        dims = (m1, m2)
        A1 = StridedView(rand(T, dims))
        A2 = StridedView(rand(T, dims))
        A3 = StridedView(rand(T, dims))
        for f2 in (identity, conj, adjoint, transpose), f1 in (identity, conj, transpose, adjoint)
            axes(f1(A1)) == axes(f2(A2)) || continue
            B1 = f1(copy(A1))
            B2 = f2(copy(A2))
            @test compare((x, y) -> copy!(y, x), AT, B1, B2)
        end
    end
end

@testset "broadcasting ($AT)" for AT in ATs
    for T in (Float32, ComplexF32)
        A0 = StridedView(rand(T, ()))
        A1 = StridedView(rand(T, (10,)))
        A2 = permutedims(StridedView(rand(T, (10, 10))), randperm(2))
        A3 = permutedims(StridedView(rand(T, (10, 10, 10))), randperm(3))
        A4 = StridedView(rand(T, (2, 0)))

        @test compare((x, y) -> x .+ sin.(y .- 3), AT, A1, A2)
        @test compare((y, z) -> y' .* z .- Ref(1 // 2), AT, A2, A3)
        @test compare((x, y, z) -> y' .* z .- max.(abs.(x), real.(z)), AT, A1, A2, A3)
        @test compare((u, y, z) -> y' .* z .- u, AT, A0, A2, A3)

        @test compare(x -> x .+ x, AT, A4)
    end
end

@testset "mapreduce ($AT)" for AT in ATs
    sz = 10
    N = 6
    for T in (Float32, ComplexF32)
        A1 = StridedView(rand(T, ntuple(Returns(sz), N)))

        @test compare(x -> sum(x; dims = (1, 3, 5)), AT, A1)
        @test compare(x -> mapreduce(sin, +, x; dims = (1, 3, 5)), AT, A1)
        @test compare(x -> sum(x; dims = (1, 3, 5)), AT, permutedims(A1, randperm(N)))
        @test compare(x -> mapreduce(sin, +, x; dims = (1, 3, 5)), AT, permutedims(A1, randperm(N)))

        A2 = sreshape(StridedView(rand(T, ntuple(Returns(sz), 3))), (sz, 1, 1, sz, sz, 1))

        @test compare((x, y) -> Strided._mapreducedim!(sin, +, identity, ntuple(Returns(sz), N), (x, y)), AT, A1, A2)
        @test compare((x, y) -> Strided._mapreducedim!(sin, +, Returns(0), ntuple(Returns(sz), N), (x, y)), AT, A1, A2)
        @test compare((x, y) -> Strided._mapreducedim!(sin, +, conj, ntuple(Returns(sz), N), (x, y)), AT, A1, A2)

        β = rand(T)
        @test compare((x, y) -> Strided._mapreducedim!(sin, +, a -> β, ntuple(Returns(sz), N), (x, y)), AT, A1, A2)
        @test compare((x, y) -> Strided._mapreducedim!(sin, +, a -> β * a, ntuple(Returns(sz), N), (x, y)), AT, A1, A2)
    end
end

@testset "reduce ($AT)" for AT in ATs
    N = 4
    for T in (Float32, ComplexF32)
        A1 = StridedView(rand(T, ntuple(Returns(10), N)))
        A2 = permutedims(StridedView(rand(T, ntuple(Returns(10), N))), randperm(N))
        @test compare(sum, AT, A1)
        @test compare(sum, AT, A2)
        @test compare(x -> maximum(real, x), AT, A1)
        @test compare(x -> maximum(abs, x), AT, A2)
        @test compare(x -> minimum(abs, x), AT, A1)
        @test compare(x -> minimum(real, x), AT, A2)

        A3 = StridedView(rand(T, (5, 5, 5)))
        @test compare(x -> prod(exp, x), AT, A3)
    end
end

@testset "0-dimensional (scalar) StridedView ($AT)" for AT in ATs
    @testset for T in (Float32, ComplexF32)
        R = fill(rand(T)) # 0-dimensional Array
        A = StridedView(AT(R))
        @test ndims(A) == 0

        # full reductions
        @test sum(A) == sum(R)
        @test prod(A) == prod(R)
        @test mapreduce(abs2, +, A) == mapreduce(abs2, +, R)
        @test maximum(abs, A) == maximum(abs, R)
        @test minimum(abs, A) == minimum(abs, R)
        @test sum(abs2, A) == sum(abs2, R)
        @test mapreduce(identity, +, A; init = one(T)) ==
            mapreduce(identity, +, R; init = one(T))

        # map / map! / copy! / fill!
        mapx = map(x -> 2x, A)
        GPUArrays.@allowscalar begin
            @test mapx[] == 2 * R[]
        end
        B = StridedView(AT(fill(zero(T))))
        map!(x -> x + one(T), B, A)
        GPUArrays.@allowscalar begin
            @test B[] == collect(R)[] + one(T)
        end
        copy!(B, A)
        GPUArrays.@allowscalar begin
            @test B[] == R[]
        end
        fill!(B, one(T))
        GPUArrays.@allowscalar begin
            @test B[] == one(T)
        end

        # offset handling: 0-dim views into a larger parent
        Psrc = AT(rand(T, 5))
        Pdst = AT(rand(T, 5))
        s = sreshape(StridedView(Psrc)[4:4], ())
        d = sreshape(StridedView(Pdst)[3:3], ())
        GPUArrays.@allowscalar begin
            @test sum(s) == Psrc[4]
        end
        copy!(d, s)
        GPUArrays.@allowscalar begin
            @test Pdst[3] == Psrc[4]
        end

        # low-level in-place reduction with a custom initop
        Pd = AT(rand(T, 5))
        d2 = sreshape(StridedView(Pd)[2:2], ())
        GPUArrays.@allowscalar begin
            prev = Pd[2]
        end
        Strided._mapreducedim!(sin, +, identity, (), (d2, A))
        GPUArrays.@allowscalar begin
            @test Pd[2] == prev + sin(R[])
        end
    end
end
